var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Boot = (function (_super) {
            __extends(Boot, _super);
            function Boot() {
                _super.apply(this, arguments);
            }
            Boot.prototype.preload = function () {
                var path = './assets/sprites/';
                var suffix = '';
                this.load.image('prerollBackground', "./assets/backgrounds/preroll.jpg" + suffix);
                this.load.atlas('preroll', path + "preloader_atlas.png" + suffix, path + "preloader_atlas.json" + suffix);
                if (Client.Config.PUBLISHER == 'M') {
                    this.load.json('dollJSON', path + 'doll.json');
                }
                Client.Config.MORE_CONFIG.domain = Client.Utils.getDomain();
                this.stage.disableVisibilityChange = true;
            };
            Boot.prototype.create = function () {
                this.input.maxPointers = 1;
                this.scale.pageAlignHorizontally = true;
                this.scale.pageAlignVertically = true;
                this.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
                this.game.state.start('Preloader', true, false);
                this.game.canvas.oncontextmenu = function (e) { Client.Utils.moreUrl('right_click'); };
            };
            return Boot;
        }(Phaser.State));
        Client.Boot = Boot;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GameEngine = (function (_super) {
            __extends(GameEngine, _super);
            function GameEngine() {
                _super.call(this, 960, 720, Phaser.AUTO, 'MainContent', '', true);
                this.state.add('Boot', Client.Boot, false);
                this.state.add('Preloader', Client.Preloader, false);
                this.state.add('Game', Client.Main, false);
                this.preserveDrawingBuffer = true;
                this.state.start('Boot');
            }
            return GameEngine;
        }(Phaser.Game));
        Client.GameEngine = GameEngine;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
window.onload = function () {
    new DressGame.Client.GameEngine();
};
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Preloader = (function (_super) {
            __extends(Preloader, _super);
            function Preloader() {
                _super.apply(this, arguments);
            }
            Preloader.prototype.preload = function () {
                console.log('VERSION_' + Client.Config.VERSION_ID + ' rev ' + Client.Config.REV);
                this.game.load.script('BlurX', './libs/BlurX.js');
                this.game.load.script('BlurY', './libs/BlurY.js');
                Client.Globals.FILENAME = Client.Config.MORE_CONFIG.gameID + ".png";
                var preloaderScreen = new Client.PreloaderScreen(this.game);
                this.preloadBack = this.add.image(0, 580, 'preroll', 'progressbar_1.png');
                this.preloadBar = this.add.sprite(this.game.world.centerX - 530 / 2, 580, 'preroll', 'progressbar_2.png');
                this.load.setPreloadSprite(this.preloadBar);
                this.preloadBar.x = this.preloadBack.x = this.game.world.centerX - this.preloadBack.width / 2;
                var path = './assets/sprites/';
                var suffix = '';
                for (var i = 0; i < Client.Config.BACK.length; i++) {
                    this.load.image("" + Client.Config.BACK[i].name, "./assets/backgrounds/" + Client.Config.BACK[i].image + "." + Client.Config.BACK[i].exp + suffix);
                }
                this.load.atlasJSONHash('main', path + "GUI.png" + suffix, path + "GUI.json" + suffix);
                this.load.audio('music', "./assets/sounds/music.mp3" + suffix);
                for (var i = 0; i < Client.Config.ATLAS.length; i++) {
                    this.load.atlasJSONHash(Client.Config.ATLAS[i], "" + path + Client.Config.ATLAS[i] + ".png" + suffix, "" + path + Client.Config.ATLAS[i] + ".json" + suffix);
                }
            };
            Preloader.prototype.create = function () {
                this.preloadBack.visible = this.preloadBar.visible = false;
                if (Client.Config.PUBLISHER == 'D') {
                    this.playButton = new Client.GlowObject(this.game, 480, 650, 'preroll', 'play_normal.png', this.onClickDU, this);
                    this.playButton.setScale = 1.05;
                    this.playButton.setGlow = false;
                }
                if (Client.Config.PUBLISHER == 'F') {
                    this.playButton = this.game.add.button(480, 620, 'main', this.onClick, this, 'play_preroll_normal.png', 'play_preroll_normal.png', 'play_preroll_down.png');
                    this.playButton.anchor.setTo(0.5, 0.5);
                }
                if (Client.Config.PUBLISHER == 'M') {
                    this.playButton = this.game.add.button(480, 620, 'main', this.onClick, this, 'play_normal.png', 'play_normal.png', 'play_down.png');
                    this.playButton.anchor.setTo(0.5, 0.5);
                }
                this.playButton.scale.x = this.playButton.scale.y = 0.1;
                var _buttonTween = this.game.add.tween(this.playButton.scale).to({ x: 1, y: 1 }, 1000, Phaser.Easing.Elastic.Out, true);
                if (Client.Config.PUBLISHER == 'M') {
                    this.playButton.events.onInputOver.add(this.onButtonOver, this);
                    this.playButton.events.onInputOut.add(this.onButtonOut, this);
                }
            };
            Preloader.prototype.onClickDU = function (context) {
                context.onClick();
            };
            Preloader.prototype.onClick = function (target) {
                if (target === void 0) { target = null; }
                var url = document.referrer;
                var l = document.createElement('a');
                l.href = url;
                var loc = l;
                window['ga']('send', {
                    hitType: 'event',
                    eventCategory: Client.Config.MORE_CONFIG.domain,
                    eventAction: Client.Config.MORE_CONFIG.gameID,
                    eventLabel: loc.hostname
                });
                Client.Globals.LOCATION = loc.hostname;
                this.game.state.start('Game');
            };
            Preloader.prototype.onButtonOver = function (target) {
                if (Client.Config.PUBLISHER == 'M' || Client.Config.PUBLISHER == 'F') {
                    var _tween1 = this.game.add.tween(target).to({ angle: 10 }, 800, Phaser.Easing.Linear.None, true);
                    var _tween2 = this.game.add.tween(target).to({ angle: -10 }, 1600, Phaser.Easing.Linear.None, false);
                    var _tween3 = this.game.add.tween(target).to({ angle: 0 }, 800, Phaser.Easing.Linear.None, false);
                    _tween1.chain(_tween2);
                    _tween2.chain(_tween3);
                    _tween3.chain(_tween1);
                }
            };
            Preloader.prototype.onButtonOut = function (target) {
                if (Client.Config.PUBLISHER == 'M' || Client.Config.PUBLISHER == 'F') {
                    this.game.tweens.removeFrom(target);
                    this.game.add.tween(target).to({ angle: 0 }, 800, Phaser.Easing.Linear.None, true);
                }
            };
            return Preloader;
        }(Phaser.State));
        Client.Preloader = Preloader;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PreloaderScreen = (function (_super) {
            __extends(PreloaderScreen, _super);
            function PreloaderScreen(game) {
                var _this = this;
                _super.call(this, game);
                this.hover = false;
                this.itemsConfig = [[-100, 180, 110, 270], [-100, 720, 300, 380], [480, 820, 480, 450], [1060, 720, 660, 380], [1060, 180, 850, 270]];
                this.game = game;
                this.onSignal = new Phaser.Signal();
                var background = new Phaser.Image(this.game, 0, 0, 'prerollBackground');
                this.add(background);
                if (Client.Config.PUBLISHER == 'D') {
                    this.itemsImage = [];
                    this.itemsConfig = [];
                    var SS = 960 / 5 - 960 / 5 / 2;
                    this.itemsConfig.push([SS, 360]);
                    this.itemsConfig.push([SS * 3, 450]);
                    this.itemsConfig.push([SS * 5, 500]);
                    this.itemsConfig.push([SS * 7, 450]);
                    this.itemsConfig.push([SS * 9, 360]);
                    var LP = [480, 190];
                    var _loop_1 = function(i) {
                        this_1.itemsImage[i] = new Phaser.Image(this_1.game, this_1.itemsConfig[i][0], this_1.itemsConfig[i][1], 'preroll', 'icon' + (i + 1).toString() + '.png');
                        this_1.add(this_1.itemsImage[i]);
                        this_1.itemsImage[i].inputEnabled = true;
                        this_1.itemsImage[i].events.onInputDown.add(this_1.onItemDown, this_1);
                        this_1.itemsImage[i].events.onInputOver.add(this_1.onScaleOver, this_1);
                        this_1.itemsImage[i].events.onInputOut.add(this_1.onScaleOut, this_1);
                        this_1.itemsImage[i].anchor.setTo(0.5, 0.5);
                        this_1.itemsImage[i].alpha = 0;
                        this_1.itemsImage[i].inputEnabled = false;
                        this_1.itemsImage[i].scale.set(0.1);
                        this_1.game.add.tween(this_1.itemsImage[i].scale).to({ x: 1, y: 1 }, 1500, Phaser.Easing.Elastic.Out, true, i * 500);
                        this_1.game.add.tween(this_1.itemsImage[i]).to({ alpha: 1 }, 800, Phaser.Easing.Circular.Out, true, i * 500)
                            .onComplete.addOnce(function () {
                            _this.itemsImage[i].inputEnabled = true;
                        }, this_1);
                    };
                    var this_1 = this;
                    for (var i = 0; i < this.itemsConfig.length; i++) {
                        _loop_1(i);
                    }
                    this.logoImage = new Phaser.Image(game, LP[0], LP[1], 'preroll', 'logo.png');
                    this.logoImage.anchor.setTo(0.5, 0.5);
                    this.add(this.logoImage);
                    this.logoImage.inputEnabled = true;
                    this.logoImage.input.pixelPerfectClick = this.logoImage.input.pixelPerfectOver = true;
                    this.logoImage.input.pixelPerfectAlpha = 10;
                    this.logoImage.events.onInputOver.add(this.onScaleOver, this);
                    this.logoImage.events.onInputOut.add(this.onScaleOut, this);
                    this.logoImage.events.onInputDown.add(this.onLogoDown, this);
                    this.logoImage.input.useHandCursor = true;
                    this.glowEmitter = this.game.add.emitter(0, 0, 100);
                    this.add(this.glowEmitter);
                    this.glowEmitter.makeParticles('preroll', 'particle_glow.png');
                    this.glowEmitter.setAlpha(1, 0.3, 3000);
                    this.glowEmitter.gravity = -10;
                    this.glowEmitter.minParticleScale = 0.5;
                    this.glowEmitter.maxParticleScale = 1;
                }
                if (Client.Config.PUBLISHER != 'D') {
                    if (Client.Config.PUBLISHER != 'M') {
                        this.itemsImage = [];
                        for (var i = 0; i < this.itemsConfig.length; i++) {
                            this.itemsImage[i] = new Phaser.Image(this.game, this.itemsConfig[i][0], this.itemsConfig[i][1], 'preroll', 'icon' + (i + 1).toString() + '.png');
                            this.add(this.itemsImage[i]);
                            this.itemsImage[i].inputEnabled = true;
                            this.itemsImage[i].events.onInputOver.add(this.onScaleOver, this);
                            this.itemsImage[i].events.onInputOut.add(this.onScaleOut, this);
                            this.itemsImage[i].input.pixelPerfectClick = this.itemsImage[i].input.pixelPerfectOver = true;
                            this.itemsImage[i].input.pixelPerfectAlpha = 10;
                            if (Client.Config.VERSION_ID != 'GD') {
                                this.itemsImage[i].events.onInputDown.add(this.onItemDown, this);
                                this.itemsImage[i].input.useHandCursor = true;
                            }
                            if (Client.Config.VERSION_ID == 'GD' && Client.Config.PUBLISHER == 'F') {
                                this.itemsImage[i].events.onInputDown.add(this.onItemDown, this);
                                this.itemsImage[i].input.useHandCursor = true;
                            }
                            this.itemsImage[i].anchor.setTo(0.5, 0.5);
                            var _tween = this.game.add.tween(this.itemsImage[i]).to({ x: this.itemsConfig[i][2], y: this.itemsConfig[i][3] }, 800, Phaser.Easing.Quadratic.Out, true, 1000 * i);
                        }
                        this.logoImage = new Phaser.Image(game, 480, 240, 'preroll', 'logo.png');
                        if (Client.Config.PUBLISHER == 'F') {
                            this.logoImage.y -= 70;
                        }
                        this.logoImage.anchor.setTo(0.5, 0.5);
                        this.add(this.logoImage);
                        this.logoImage.inputEnabled = true;
                        this.logoImage.input.pixelPerfectClick = this.logoImage.input.pixelPerfectOver = true;
                        this.logoImage.input.pixelPerfectAlpha = 10;
                        this.logoImage.events.onInputOver.add(this.onScaleOver, this);
                        this.logoImage.events.onInputOut.add(this.onScaleOut, this);
                        this.logoImage.events.onInputDown.add(this.onLogoDown, this);
                        this.logoImage.input.useHandCursor = true;
                        this.glowEmitter = this.game.add.emitter(0, 0, 100);
                        this.add(this.glowEmitter);
                        this.glowEmitter.makeParticles('preroll', 'particle_glow.png');
                        this.glowEmitter.setAlpha(1, 0.3, 3000);
                        this.glowEmitter.gravity = -10;
                        this.glowEmitter.minParticleScale = 0.5;
                        this.glowEmitter.maxParticleScale = 1;
                    }
                    if (Client.Config.PUBLISHER == 'M') {
                        this.crownEmitter = this.game.add.emitter(0, 0, 100);
                        this.add(this.crownEmitter);
                        this.crownEmitter.makeParticles('preroll', 'particle_crown.png');
                        this.crownEmitter.setRotation(-50, 50);
                        this.crownEmitter.setAlpha(1, 0.3, 4000);
                        this.crownEmitter.gravity = -10;
                        this.crownEmitter.minParticleScale = 0.5;
                        this.crownEmitter.maxParticleScale = 1;
                        this.crownEmitter.x = 500;
                        this.crownEmitter.y = 100;
                        var spriterLoader = new Spriter.Loader();
                        var spriterFile = new Spriter.SpriterJSON(this.game.cache.getJSON('dollJSON'));
                        var spriterData = spriterLoader.load(spriterFile);
                        this._spriterGroup = new Spriter.SpriterGroup(this.game, spriterData, 'preroll', 'girl', 0, 10);
                        this._spriterGroup.position.setTo(200, 720 - this._spriterGroup.height);
                        this.add(this._spriterGroup);
                        var me_1 = this;
                        this._spriterGroup.onLoop.add(function (data) {
                            me_1._spriterGroup.playAnimationById(0);
                        }, this);
                        this._spriterGroup.onEvent.add(function (data, event) {
                            this.crownEmitter.start(true, 4000, null, 25);
                        }, this);
                        this.items = [];
                        if (Client.Config.VERSION_ID != 'GD') {
                            for (var i = 0; i < PreloaderScreen.PREROLLITEMS.length; i++) {
                                this.items[i] = new Client.GlowObject(game, PreloaderScreen.PREROLLITEMS[i]['position'][0], PreloaderScreen.PREROLLITEMS[i]['position'][1], 'preroll', PreloaderScreen.PREROLLITEMS[i]['image'], this.onItemDown, this);
                                this.add(this.items[i]);
                                this.items[i].scaleOver = 1.1;
                                this.shakeItem(this.items[i], i * 1500);
                            }
                        }
                        this.logoImage = new Phaser.Image(game, 480, 415, 'preroll', 'logo.png');
                        this.logoImage.anchor.setTo(0.5, 0.5);
                        this.add(this.logoImage);
                        this.logoImage.inputEnabled = true;
                        this.logoImage.input.pixelPerfectClick = this.logoImage.input.pixelPerfectOver = true;
                        this.logoImage.input.pixelPerfectAlpha = 10;
                        this.logoImage.input.useHandCursor = true;
                        this.logoImage.events.onInputOver.add(this.onScaleOver, this);
                        this.logoImage.events.onInputOut.add(this.onScaleOut, this);
                        this.logoImage.events.onInputDown.add(this.onLogoDown, this);
                        this.glowEmitter = this.game.add.emitter(0, 0, 100);
                        this.add(this.glowEmitter);
                        this.glowEmitter.makeParticles('preroll', 'particle_glow.png');
                        this.glowEmitter.setAlpha(1, 0.3, 3000);
                        this.glowEmitter.gravity = -10;
                        this.glowEmitter.minParticleScale = 0.5;
                        this.glowEmitter.maxParticleScale = 1;
                    }
                }
            }
            PreloaderScreen.prototype.onScaleOver = function (target) {
                this.game.tweens.removeFrom(target.scale);
                this.game.add.tween(target.scale).to({ x: 1.05, y: 1.05 }, 250, Phaser.Easing.Linear.None, true);
                this.hover = true;
            };
            PreloaderScreen.prototype.onScaleOut = function (target) {
                this.game.tweens.removeFrom(target.scale);
                this.game.add.tween(target.scale).to({ x: 1, y: 1 }, 250, Phaser.Easing.Linear.None, true);
                this.hover = false;
            };
            PreloaderScreen.prototype.onItemDown = function (target) {
                Client.Utils.moreUrl('preloader_category');
            };
            PreloaderScreen.prototype.onLogoDown = function (target) {
                Client.Utils.moreUrl('preloader_logo');
            };
            PreloaderScreen.prototype.update = function () {
                _super.prototype.update.call(this);
                if (Client.Config.PUBLISHER == 'M') {
                    this._spriterGroup.updateAnimation();
                }
                if (this.hover) {
                    this.glowEmitter.x = this.game.input.x;
                    this.glowEmitter.y = this.game.input.y;
                    this.glowEmitter.start(true, 3000, null, 25);
                }
            };
            PreloaderScreen.prototype.hide = function () {
                if (Client.Config.PUBLISHER != 'M') {
                    this.visible = false;
                    this.glowEmitter.kill();
                    this.hover = false;
                }
                else {
                    this._spriterGroup.onEvent.removeAll();
                    this._spriterGroup.onLoop.removeAll();
                    this._spriterGroup.destroy(true);
                    for (var prop in PreloaderScreen.PREROLLITEMS) {
                        this.items[prop].destroy(true);
                    }
                    this.visible = false;
                    this.glowEmitter.kill();
                    this.crownEmitter.kill();
                    this.hover = false;
                }
            };
            PreloaderScreen.prototype.show = function (config) {
                this.config = config;
                this.visible = true;
            };
            PreloaderScreen.prototype.shakeItem = function (target, delay) {
                var _tween0 = this.game.add.tween(target).to({ angle: 0 }, delay, Phaser.Easing.Linear.None, true);
                var _tween1 = this.game.add.tween(target).to({ angle: 10 }, 400, Phaser.Easing.Linear.None, false, 4000);
                var _tween2 = this.game.add.tween(target).to({ angle: -10 }, 800, Phaser.Easing.Linear.None, false);
                var _tween3 = this.game.add.tween(target).to({ angle: 0 }, 400, Phaser.Easing.Linear.None, false);
                _tween3.onComplete.add(function () {
                    this.glowEmitter.x = target.x;
                    this.glowEmitter.y = target.y;
                    this.glowEmitter.start(true, 1500, null, 25);
                }, this);
                _tween0.chain(_tween1);
                _tween1.chain(_tween2);
                _tween2.chain(_tween3);
                _tween3.chain(_tween1);
            };
            PreloaderScreen.PREROLLITEMS = [
                { id: 'dress', image: 'dressup.png', position: [160, 180] },
                { id: 'princess', image: 'princess.png', position: [775, 175] },
                { id: 'makeup', image: 'makeup.png', position: [800, 430] },
                { id: 'hair', image: 'hair.png', position: [155, 460] },
            ];
            return PreloaderScreen;
        }(Phaser.Group));
        Client.PreloaderScreen = PreloaderScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Carousel = (function (_super) {
            __extends(Carousel, _super);
            function Carousel(game, id, idCase) {
                _super.call(this, game);
                this.onSignal = new Phaser.Signal();
                this.glow = new Client.GlowFilter(this.game, 0.05);
                this.idCase = idCase;
                this.type = id;
                this.imagesBack = [];
                this.imagesGlow = [];
                var tmpImage;
                var bmd;
                var back = Client.DressConfig.CAROUSELS[this.type]['images'];
                for (var i = 0; i < back.length; i++) {
                    if (back[i]) {
                        this.imagesBack[i] = new Phaser.Image(this.game, 0, 0, Client.DressConfig.CAROUSELS[this.type]['atlas'], back[i] + ".png");
                        this.add(this.imagesBack[i]);
                        this.imagesBack[i].anchor.setTo(0.5, 0.5);
                        this.imagesBack[i].name = back[i];
                        this.imagesBack[i].inputEnabled = true;
                        this.imagesBack[i].input.useHandCursor = true;
                        this.imagesBack[i].input.pixelPerfectClick = this.imagesBack[i].input.pixelPerfectOver = true;
                        this.imagesBack[i].input.pixelPerfectAlpha = 10;
                        this.imagesBack[i].events.onInputDown.add(this.onClick, this);
                        this.imagesBack[i].events.onInputOver.add(this.onScaleOver, this);
                        this.imagesBack[i].events.onInputOut.add(this.onScaleOut, this);
                    }
                }
                if (Client.DressConfig.CAROUSELS[this.type]['anim'] == 'S') {
                    this.game.add.tween(this.scale).to({ x: 1.03, y: 1.03 }, 500, Phaser.Easing.Linear.None, true, 0, Number.MAX_VALUE, true);
                }
            }
            Object.defineProperty(Carousel.prototype, "setBegin", {
                set: function (num) {
                    this.begin = num;
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(Carousel.prototype, "setEnd", {
                set: function (num) {
                    this.end = num;
                },
                enumerable: true,
                configurable: true
            });
            Carousel.prototype.onClick = function () {
                this.onSignal.dispatch({ type: this.idCase, id: this.type });
                if (Client.DressConfig.CAROUSELS[this.type]['anim'] == 'S') {
                    this.scale.set(1);
                    Client.Globals.GAME.tweens.removeFrom(this.scale);
                    Client.DressConfig.CAROUSELS[this.type]['anim'] = null;
                }
            };
            Carousel.prototype.onScaleOver = function (target) {
                if (!this.imagesGlow[this.view]) {
                    var tmpImage = new Phaser.Image(this.game, 0, 0, Client.DressConfig.CAROUSELS[this.type]['atlas'], target.name + ".png");
                    var bmd = this.game.make.bitmapData();
                    bmd.load(tmpImage);
                    bmd.processPixelRGB(Client.Utils.paintWhite, this);
                    this.imagesGlow[this.view] = new Phaser.Image(this.game, 0, 0, bmd);
                    this.imagesGlow[this.view].filters = [this.glow];
                    this.imagesGlow[this.view].anchor.setTo(0.5, 0.5);
                    this.add(this.imagesGlow[this.view]);
                    this.setChildIndex(this.imagesGlow[this.view], 0);
                }
                this.imagesGlow[this.view].visible = true;
            };
            Carousel.prototype.onScaleOut = function (target) {
                for (var i = 0; i < this.imagesGlow.length; i++) {
                    if (this.imagesGlow[i]) {
                        this.imagesGlow[i].visible = false;
                    }
                }
                this.scale.set(1);
            };
            Carousel.prototype.setView = function (id) {
                this.view = id;
                if (this.view >= this.imagesBack.length) {
                    this.view = 0;
                }
                this.hideAll();
                if (this.imagesBack[this.view]) {
                    this.imagesBack[this.view].visible = true;
                }
            };
            Carousel.prototype.hideAll = function () {
                for (var i = 0; i < this.imagesBack.length; i++) {
                    if (this.imagesBack[i]) {
                        this.imagesBack[i].visible = false;
                    }
                }
            };
            Carousel.prototype.hide = function () {
                this.visible = false;
            };
            return Carousel;
        }(Phaser.Group));
        Client.Carousel = Carousel;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var CaseMore = (function (_super) {
            __extends(CaseMore, _super);
            function CaseMore(game, image, atlas, tinsel, maxTinsel, scaling) {
                if (tinsel === void 0) { tinsel = false; }
                if (maxTinsel === void 0) { maxTinsel = -1; }
                if (scaling === void 0) { scaling = false; }
                _super.call(this, game);
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.more = new Client.GlowObject(this.game, 480, 360, atlas, image + ".png", function () { Client.Utils.moreUrl('ingame_more_games'); }, this);
                    if (scaling) {
                        this.more.scaleOver = 1.05;
                    }
                    this.add(this.more);
                    if (tinsel) {
                        if (maxTinsel == -1) {
                            this.tinsel = new Phaser.Image(this.game, 480, 360, atlas, image + "_tinsel.png");
                            this.tinsel.anchor.set(0.5);
                            this.add(this.tinsel);
                            this.startAnim();
                        }
                        else {
                            this.tinsel = new Client.Lights(this.game, maxTinsel, image + "_tinsel", atlas);
                            this.add(this.tinsel);
                        }
                    }
                }
            }
            CaseMore.prototype.setPos = function (x, y) {
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.more.x = x;
                    this.more.y = y;
                }
            };
            CaseMore.prototype.startAnim = function () {
                if (this.tinsel) {
                    this.game.add.tween(this.tinsel).to({ alpha: 0 }, 300, Phaser.Easing.Linear.None, true, 0, Number.MAX_VALUE, true);
                }
            };
            Object.defineProperty(CaseMore.prototype, "setGlowColor", {
                set: function (arr) {
                    this.more.setGlowColor = arr;
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(CaseMore.prototype, "setPulse", {
                set: function (mode) {
                    this.more.setPulse = mode;
                },
                enumerable: true,
                configurable: true
            });
            CaseMore.prototype.update = function () {
                _super.prototype.update.call(this);
            };
            return CaseMore;
        }(Phaser.Group));
        Client.CaseMore = CaseMore;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Doll = (function (_super) {
            __extends(Doll, _super);
            function Doll(game, id) {
                _super.call(this, game);
                this.images = [];
                this.glowed = false;
                this.generalItems = ['body', 'head', 'eyes', 'hand', 'hand_r', 'hand_l', 'finger', 'finger_l', 'finger_r', 'under', 'under_t', 'under_b', 'shadow'];
                this.id = id;
                this.game = game;
                this.imagesGroup = new Phaser.Group(this.game, this);
                for (var i = 0; i < Client.DressConfig.DOLLS[this.id]['images'].length; i++) {
                    this.images.push(new Phaser.Image(this.game, 0, 0, Client.DressConfig.DOLLS[this.id]['atlas'], Client.DressConfig.DOLLS[this.id]['images'][i] + ".png"));
                    this.images[i].name = Client.DressConfig.DOLLS[this.id]['images'][i];
                    this.imagesGroup.add(this.images[i]);
                    if (this.images[i].name == 'body') {
                        this.images[i].inputEnabled = true;
                        this.images[i].input.pixelPerfectClick = this.images[i].input.pixelPerfectOver = true;
                        this.images[i].input.pixelPerfectAlpha = 20;
                        this.images[i].events.onInputOver.add(this.onOver, this);
                        this.images[i].events.onInputOut.add(this.onOut, this);
                        this.images[i].events.onInputDown.add(this.onClick, this);
                        this.images[i].input.useHandCursor = true;
                    }
                }
            }
            Doll.prototype.getItem = function (ID) {
                for (var i = 0; i < Client.DressConfig.DOLLS[this.id]['images'].length; i++) {
                    if (ID == this.images[i].name) {
                        return this.images[i];
                    }
                }
                return -1;
            };
            Doll.prototype.hide = function () {
                for (var i = 0; i < Client.DressConfig.DOLLS[this.id]['images'].length; i++) {
                    this.images[i].visible = false;
                }
            };
            Doll.prototype.setView = function () {
                var items;
                this.hide();
                for (var i = 0; i < Client.DressConfig.DOLLS[this.id]['images'].length; i++) {
                    for (var j = 0; j < this.generalItems.length; j++) {
                        if (this.images[i].name == this.generalItems[j]) {
                            this.images[i].visible = true;
                        }
                    }
                }
                for (var i = 0; i < Client.Globals.DOLLS_VIEW[this.id].length; i++) {
                    if (Client.DressConfig.DOLLS[this.id]['sets'][i][Client.Globals.DOLLS_VIEW[this.id][i]]) {
                        items = Client.DressConfig.DOLLS[this.id]['items'][Client.DressConfig.DOLLS[this.id]['sets'][i][Client.Globals.DOLLS_VIEW[this.id][i]]];
                        for (var j = 0; j < items.length; j++) {
                            this.getItem(items[j]).visible = true;
                        }
                    }
                }
                if (Client.Globals.GIRL[this.id].isActive) {
                    if (this.glowBack) {
                        this.removeChild(this.glowBack);
                    }
                    this.createGlowBack();
                    if (!this.glowed) {
                        this.glowBack.visible = false;
                    }
                }
                if (Client.DressConfig.DOLLS[this.id]['noUnder']) {
                    if (Client.DressConfig.DOLLS[this.id]['noUnder'] == 'tb') {
                        if (Client.Globals.DOLLS_VIEW[this.id][2] == 0 && Client.Globals.DOLLS_VIEW[this.id][1] == 0) {
                            Client.Globals.DOLLS_VIEW[this.id][2] = 1;
                            this.setView();
                        }
                        if (Client.Globals.DOLLS_VIEW[this.id][3] == 0 && Client.Globals.DOLLS_VIEW[this.id][1] == 0) {
                            Client.Globals.DOLLS_VIEW[this.id][3] = 1;
                            this.setView();
                        }
                    }
                    if (Client.DressConfig.DOLLS[this.id]['noUnder'] == 'dr') {
                        if (Client.Globals.DOLLS_VIEW[this.id][1] == 0) {
                            Client.Globals.DOLLS_VIEW[this.id][1] = 1;
                            this.setView();
                        }
                    }
                }
                if (this.getItem('under') != -1) {
                    if (Client.Globals.DOLLS_VIEW[this.id][1] != 0) {
                        this.getItem('under').visible = false;
                    }
                }
                if (this.getItem('under_t') != -1) {
                    if (Client.Globals.DOLLS_VIEW[this.id][2] != 0 || Client.Globals.DOLLS_VIEW[this.id][1] != 0) {
                        this.getItem('under_t').visible = false;
                    }
                }
                if (this.getItem('under_b') != -1) {
                    if (Client.Globals.DOLLS_VIEW[this.id][3] != 0 || Client.Globals.DOLLS_VIEW[this.id][1] != 0) {
                        this.getItem('under_b').visible = false;
                    }
                }
                var wearClothes = [];
                var wearGroup = [];
                for (var i = 0; i < Client.DressConfig.DOLLS[this.id]['images'].length; i++) {
                    if (this.images[i].visible && !Client.Utils.inArray(this.images[i].name, this.generalItems)) {
                        wearClothes.push(this.images[i].name);
                    }
                }
                for (var prop in Client.DressConfig.DOLLS[this.id]['items']) {
                    if (Client.Utils.inArray(Client.DressConfig.DOLLS[this.id]['items'][prop][0], wearClothes)) {
                        wearGroup.push(prop);
                    }
                }
                if (Client.DressConfig.DRESSING_CONFIG[this.id]) {
                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['hidden'] && Client.Globals.GIRL_ID == this.id) {
                        Client.Event.onScreenEvent.dispatch({ type: 'case', action: 'hide', elems: wearGroup });
                    }
                }
                wearClothes = [];
                wearGroup = [];
                items = null;
            };
            Doll.prototype.createGlowBack = function () {
                var bmd = Client.Utils.makeShoot(this.game, this.getItem('body').width, this.getItem('body').height, this);
                bmd.blendSourceAtop();
                bmd.fill(0xFF, 0xFF, 0xFF);
                this.glowBack = new Phaser.Image(this.game, 0, 0, bmd);
                this.add(this.glowBack);
                this.glowBack.filters = [new Client.GlowFilter(this.game, 0.05)];
                this.setChildIndex(this.glowBack, 0);
            };
            Object.defineProperty(Doll.prototype, "setActive", {
                set: function (status) {
                    this.isActive = status;
                    this.getItem('body').input.useHandCursor = this.isActive;
                    if (!status && this.glowBack && !this.isGlow) {
                        this.glowBack.visible = false;
                    }
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(Doll.prototype, "setGlow", {
                set: function (status) {
                    this.isGlow = status;
                },
                enumerable: true,
                configurable: true
            });
            Doll.prototype.onClick = function (target) {
                if (this.isActive) {
                    Client.Event.onDollEvent.dispatch({ type: 'doll', id: this.id });
                }
                this.isGlow = false;
            };
            Doll.prototype.onOut = function (target) {
                if (this.isActive) {
                    if (this.glowBack && !this.isGlow) {
                        if (!this.glowed) {
                            this.glowBack.visible = false;
                        }
                    }
                }
            };
            Object.defineProperty(Doll.prototype, "glowAlways", {
                set: function (mode) {
                    this.glowed = mode;
                },
                enumerable: true,
                configurable: true
            });
            Doll.prototype.onOver = function (target) {
                if (this.isActive) {
                    if (this.glowBack) {
                        this.glowBack.visible = true;
                    }
                }
            };
            return Doll;
        }(Phaser.Group));
        Client.Doll = Doll;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var DressCase = (function (_super) {
            __extends(DressCase, _super);
            function DressCase(game) {
                _super.call(this, game);
                this.AllItemsArray = [];
                this.hiddenArr = [];
                this.carousels = [];
                this.page = -1;
                this.isActive = true;
                this.insideFrame = game.add.group(this);
                this.mainFrame = game.add.group(this);
                this.buttonsFrame = game.add.group(this);
                this.glow = new Client.GlowFilter(this.game, 0.05);
                this.frontFrame = game.add.group(this);
                Client.Event.onItemsEvent.add(this.onPageClick, this);
            }
            Object.defineProperty(DressCase.prototype, "setActive", {
                set: function (mode) {
                    this.isActive = mode;
                },
                enumerable: true,
                configurable: true
            });
            DressCase.prototype.setView = function (id, _page) {
                if (_page === void 0) { _page = 0; }
                this.id = id;
                this.page = _page;
                this.dollID = Client.DressConfig.DRESSING_CONFIG[this.id]['doll'];
                this.add(this.mainFrame);
                this.add(this.buttonsFrame);
                for (var prop in this.itemImages) {
                    this.itemImages[prop].input.destroy();
                    this.itemImages[prop].destroy();
                }
                for (var prop in this.itemBacks) {
                    this.itemBacks[prop].destroy();
                }
                for (var prop in this.itemGroups) {
                    this.itemGroups[prop].destroy();
                }
                if (this.carousels) {
                    for (var i = 0; i < this.carousels.length; i++) {
                        this.carousels[i].onSignal.removeAll();
                        this.carousels[i].destroy();
                    }
                }
                this.itemGroups = [];
                this.itemImages = [];
                this.itemBacks = [];
                this.glow = new Client.GlowFilter(this.game, 0.05);
                this.AllItemsArray = [];
                for (var i = 0; i < Client.DressConfig.DRESSING_CONFIG[this.id]['pages'].length; i++) {
                    for (var j = 0; j < Client.DressConfig.DRESSING_CONFIG[this.id]['pages'][i].length; j++) {
                        if (!Client.Utils.inArray(Client.DressConfig.DRESSING_CONFIG[this.id]['pages'][i][j], this.AllItemsArray)) {
                            this.AllItemsArray.push(Client.DressConfig.DRESSING_CONFIG[this.id]['pages'][i][j]);
                        }
                    }
                }
                for (var i = 0; i < this.AllItemsArray.length; i++) {
                    this.itemGroups[this.AllItemsArray[i]] = new Phaser.Group(this.game);
                    this.mainFrame.add(this.itemGroups[this.AllItemsArray[i]]);
                    this.itemImages[this.AllItemsArray[i]] = new Phaser.Image(this.game, 0, 0, Client.DressConfig.DRESSING_CONFIG[this.id]['atlas'], this.AllItemsArray[i] + ".png");
                    this.itemImages[this.AllItemsArray[i]].inputEnabled = true;
                    this.itemImages[this.AllItemsArray[i]].input.pixelPerfectClick = true;
                    this.itemImages[this.AllItemsArray[i]].input.pixelPerfectOver = true;
                    this.itemImages[this.AllItemsArray[i]].input.pixelPerfectAlpha = 10;
                    this.itemImages[this.AllItemsArray[i]].events.onInputOver.add(this.onScaleOver, this);
                    this.itemImages[this.AllItemsArray[i]].events.onInputOut.add(this.onScaleOut, this);
                    this.itemImages[this.AllItemsArray[i]].events.onInputDown.add(this.onItemClick, this);
                    this.itemImages[this.AllItemsArray[i]].name = this.AllItemsArray[i];
                    this.itemImages[this.AllItemsArray[i]].input.useHandCursor = true;
                    this.itemGroups[this.AllItemsArray[i]].add(this.itemImages[this.AllItemsArray[i]]);
                }
                this.carousels = [];
                var caros = Client.DressConfig.DRESSING_CONFIG[this.id]['carousels'];
                if (caros) {
                    for (var i = 0; i < caros.length; i++) {
                        this.carousels[i] = new Client.Carousel(this.game, caros[i]['id'], i);
                        this.add(this.carousels[i]);
                        this.carousels[i].x = caros[i]['x'] ? caros[i]['x'] : 960 / 2;
                        this.carousels[i].y = caros[i]['y'] ? caros[i]['y'] : 720 / 2;
                        this.carousels[i].scale.x = this.carousels[i].scale.y = caros[i]['scale'] ? caros[i]['scale'] : 1;
                        this.carousels[i].onSignal.add(this.onCarousel, this);
                    }
                }
                this.visible = true;
                this.setPage(this.page);
                if (this.arrowLeft) {
                    this.remove(this.arrowLeft, true);
                }
                if (this.arrowRight) {
                    this.remove(this.arrowRight, true);
                }
                if (Client.DressConfig.DRESSING_CONFIG[this.id]['arrow']) {
                    var arrowAtlas = Client.DressConfig.DRESSING_CONFIG[this.id]['arrow'].atlas ? Client.DressConfig.DRESSING_CONFIG[this.id]['arrow'].atlas : Client.DressConfig.DRESSING_CONFIG[this.id]['atlas'];
                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['arrow'].view == 'two') {
                        this.arrowLeft = new Client.GlowObject(this.game, 960 / 2, 720 / 2, arrowAtlas, 'arrow_l.png', this.onArrow, this, 'AL');
                        this.add(this.arrowLeft);
                        this.arrowRight = new Client.GlowObject(this.game, 960 / 2, 720 / 2, arrowAtlas, 'arrow_r.png', this.onArrow, this, 'AR');
                        this.add(this.arrowRight);
                    }
                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['arrow'].view == 'one') {
                        this.arrowRight = new Client.GlowObject(this.game, 960 / 2, 720 / 2, arrowAtlas, 'arrow.png', this.onArrow, this, 'AR');
                        this.add(this.arrowRight);
                    }
                }
            };
            DressCase.prototype.onScaleOver = function (target) {
                if (!this.itemBacks[target.name]) {
                    var tmpImage = new Phaser.Image(this.game, 0, 0, Client.DressConfig.DRESSING_CONFIG[this.id]['atlas'], target.name + ".png");
                    var bmd = this.game.make.bitmapData();
                    bmd.load(tmpImage);
                    bmd.blendSourceAtop();
                    bmd.fill(0xFF, 0xFF, 0xFF);
                    this.itemBacks[target.name] = new Phaser.Image(this.game, 0, 0, bmd);
                    this.itemBacks[target.name].filters = [this.glow];
                    this.itemBacks[target.name].scale.x = this.itemImages[target.name].scale.x;
                    this.itemBacks[target.name].scale.y = this.itemImages[target.name].scale.y;
                    this.itemGroups[target.name].add(this.itemBacks[target.name]);
                    this.itemGroups[target.name].setChildIndex(this.itemBacks[target.name], 0);
                }
                this.itemBacks[target.name].visible = true;
            };
            DressCase.prototype.onScaleOut = function (target) {
                if (this.itemBacks[target.name]) {
                    this.itemBacks[target.name].visible = false;
                }
            };
            DressCase.prototype.onPageClick = function (params) {
                switch (params['type']) {
                    case 'casePage':
                        this.setPage(Number(params['id']));
                        break;
                }
            };
            DressCase.prototype.onItemClick = function (target) {
                if (this.isActive) {
                    var i, j, items, itemSet, itemId;
                    for (i = 0; i < Client.DressConfig.DOLLS[this.dollID]['sets'].length; i++) {
                        for (j = 0; j < Client.DressConfig.DOLLS[this.dollID]['sets'][i].length; j++) {
                            if (Client.DressConfig.DOLLS[this.dollID]['sets'][i][j] == target.name) {
                                itemSet = i;
                                itemId = j;
                                if (j == Client.Globals.DOLLS_VIEW[this.dollID][i]) {
                                    if (Client.DressConfig.DOLLS[this.dollID]['sets'][i][0] == null) {
                                        Client.Globals.DOLLS_VIEW[this.dollID][i] = 0;
                                    }
                                }
                                else {
                                    Client.Globals.DOLLS_VIEW[this.dollID][i] = j;
                                }
                            }
                        }
                    }
                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['combined']) {
                        var combinations = Client.DressConfig.DRESSING_CONFIG[this.id]['combined'];
                        for (i = 0; i < combinations.length; i++) {
                            if (combinations[i]['set1'] == itemSet) {
                                for (var j_1 = 0; j_1 < combinations[i]['set2'].length; j_1++)
                                    Client.Globals.DOLLS_VIEW[this.dollID][combinations[i]['set2'][j_1]] = 0;
                            }
                            for (j = 0; j < combinations[i]['set2'].length; j++) {
                                if (combinations[i]['set2'][j] == itemSet)
                                    Client.Globals.DOLLS_VIEW[this.dollID][combinations[i]['set1']] = 0;
                            }
                        }
                    }
                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['notZero']) {
                        var noZero = Client.DressConfig.DRESSING_CONFIG[this.id]['notZero'];
                        for (i = 0; i < noZero.length; i++) {
                            var dontShow = false;
                            for (var j_2 = 0; j_2 < noZero[i]['sets'].length; j_2++) {
                                if (Client.Globals.DOLLS_VIEW[this.dollID][noZero[i]['sets'][j_2]] > 0)
                                    dontShow = true;
                            }
                            if (dontShow)
                                Client.Globals.DOLLS_VIEW[this.dollID][noZero[i]['image']] = 0;
                            else
                                Client.Globals.DOLLS_VIEW[this.dollID][noZero[i]['image']] = 1;
                        }
                    }
                    Client.Event.onItemsEvent.dispatch({ type: 'case', id: this.id });
                }
            };
            DressCase.prototype.onArrow = function (context) {
                this.name == 'AL' ? context.onArrowLeft() : context.onArrowRight();
            };
            DressCase.prototype.getCnt = function () {
                if (Client.DressConfig.DRESSING_CONFIG[this.id]['skiped'] && Client.Config.VERSION_ID != 'FULL') {
                    return 2;
                }
                else {
                    return 1;
                }
            };
            DressCase.prototype.onArrowLeft = function () {
                if (this.page == 0) {
                    this.page = Client.DressConfig.DRESSING_CONFIG[this.id]['pages'].length - this.getCnt();
                }
                else {
                    this.page--;
                }
                this.setPage(this.page);
            };
            DressCase.prototype.onArrowRight = function () {
                if (this.page < Client.DressConfig.DRESSING_CONFIG[this.id]['pages'].length - this.getCnt()) {
                    this.page++;
                }
                else {
                    this.page = 0;
                }
                this.setPage(this.page);
            };
            DressCase.prototype.setPage = function (page) {
                var items;
                this.page = page;
                this.insideFrame.removeAll(true);
                this.frontFrame.removeAll(true);
                if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'] != null) {
                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page]) {
                        for (var prop in Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page]) {
                            if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['type'] == 'i') {
                                this.game.add.image(Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['x'] ? Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['x'] : 0, Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['y'] ? Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['y'] : 0, Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['atlas'] ? Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['atlas'] : Client.DressConfig.DRESSING_CONFIG[this.id]['atlas'], Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['image'] + ".png", Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['top'] ? this.frontFrame : this.insideFrame);
                            }
                            if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['type'] == 'm') {
                                var mr = new Client.CaseMore(this.game, Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['image'], Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['atlas'] ? Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['atlas'] : Client.DressConfig.DRESSING_CONFIG[this.id]['atlas'], Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['tinsel'] ? true : false, Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['maxTinsel'] ? Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['maxTinsel'] : -1, Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['scaling'] ? true : false);
                                if (Client.Config.VERSION_ID == 'FULL') {
                                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['x'] && Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['y']) {
                                        mr.setPos(Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['x'], Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['y']);
                                    }
                                    Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['top'] ? this.frontFrame.add(mr) : this.insideFrame.add(mr);
                                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['color']) {
                                        mr.setGlowColor = Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['color'];
                                    }
                                    if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['pulse']) {
                                        mr.setPulse = Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['pulse'];
                                    }
                                }
                            }
                            if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['type'] == 'p') {
                                var pr = new Client.PromoBtn(this.game, Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['atlas'] ? Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['atlas'] : Client.DressConfig.DRESSING_CONFIG[this.id]['atlas'], Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['image'], Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['ID']);
                                Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['x'] ? pr.x = Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['x'] : pr.x = 960 / 2;
                                Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['y'] ? pr.x = Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['y'] : pr.y = 720 / 2;
                                if (Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['scaling']) {
                                    this.game.add.tween(pr.scale).to({ x: 1.05, y: 1.05 }, 450, Phaser.Easing.Linear.None, true, 10, Number.MAX_VALUE, true);
                                }
                                Client.DressConfig.DRESSING_CONFIG[this.id]['inside'][this.page][prop]['top'] ? this.frontFrame.add(pr) : this.insideFrame.add(pr);
                            }
                        }
                    }
                }
                for (var prop in this.AllItemsArray) {
                    this.itemGroups[this.AllItemsArray[prop]].visible = false;
                    if (Client.Utils.inArray(this.AllItemsArray[prop], Client.DressConfig.DRESSING_CONFIG[this.id]['pages'][this.page])) {
                        this.itemGroups[this.AllItemsArray[prop]].visible = true;
                        if (Client.DressConfig.DRESSING_CONFIG[this.id]['hidden'] && Client.Globals.GIRL_ID != -1) {
                            for (var prop2 in this.itemGroups) {
                                if (Client.Utils.inArray(prop2, this.hiddenArr)) {
                                    this.itemGroups[prop2].visible = false;
                                }
                            }
                        }
                    }
                }
                this.hiddenArr = [];
                var caros = Client.DressConfig.DRESSING_CONFIG[this.id]['carousels'];
                if (caros) {
                    for (var i = 0; i < caros.length; i++) {
                        if (Client.DressConfig.DRESSING_CONFIG[this.id]['carousels'][i]['page'] != -1) {
                            if (Client.DressConfig.DRESSING_CONFIG[this.id]['carousels'][i]['page'] == this.page) {
                                this.carousels[i].visible = true;
                            }
                            else {
                                this.carousels[i].visible = false;
                            }
                        }
                        this.carousels[i].setBegin = Client.DressConfig.CAROUSELS[Client.DressConfig.DRESSING_CONFIG[this.id]['carousels'][i].id].begin;
                        this.carousels[i].setEnd = Client.DressConfig.CAROUSELS[Client.DressConfig.DRESSING_CONFIG[this.id]['carousels'][i].id].end;
                        this.setCarosView(this.carousels[i]);
                    }
                }
                Client.Event.onPageEvent.dispatch({ type: 'pageUpdate', id: this.id });
            };
            DressCase.prototype.setCarosView = function (caros) {
                var ID = 0;
                if (Client.Globals.DOLLS_VIEW[this.dollID][caros.view] == 0) {
                    ID = 0;
                }
                if (Client.Globals.DOLLS_VIEW[this.dollID][caros.view] >= caros.begin &&
                    Client.Globals.DOLLS_VIEW[this.dollID][caros.view] <= caros.end) {
                    var arr = [];
                    for (var i = caros.begin; i <= caros.end; i++) {
                        arr.push(i);
                    }
                    ID = arr.indexOf(Client.Globals.DOLLS_VIEW[this.dollID][caros.view]) + 1;
                }
                caros.setView(ID);
            };
            DressCase.prototype.onCarousel = function (data) {
                if (this.isActive) {
                    var view = Client.DressConfig.DRESSING_CONFIG[this.id]['carousels'][data['type']]['view'];
                    Client.Globals.DOLLS_VIEW[this.dollID][view] = Client.DressConfig.CAROUSELS[data['id']]['begin'] + this.carousels[data['type']].view;
                    this.carousels[data['type']].view++;
                    this.carousels[data['type']].setView(this.carousels[data['type']].view);
                    Client.Event.onItemsEvent.dispatch({ type: 'case', id: this.id });
                }
            };
            Object.defineProperty(DressCase.prototype, "showArrows", {
                set: function (mode) {
                    this.setChildIndex(this.buttonsFrame, this.children.length - 1);
                    this.buttonsFrame.visible = mode;
                },
                enumerable: true,
                configurable: true
            });
            DressCase.prototype.hidden = function (elems) {
                this.hiddenArr = elems;
                this.setView(this.id, this.page);
            };
            return DressCase;
        }(Phaser.Group));
        Client.DressCase = DressCase;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ExtraElemDecor = (function (_super) {
            __extends(ExtraElemDecor, _super);
            function ExtraElemDecor(game, atlas, path) {
                _super.call(this, game);
                this.game = game;
                this.atlas = atlas;
                this.path = path;
                this.createGraphics();
            }
            ExtraElemDecor.prototype.createGraphics = function () {
                this.img = new Phaser.Image(this.game, 0, 0, this.atlas, this.path + ".png");
                this.add(this.img);
                this.lmp = new Client.SingleLamp(this.game, this.atlas, this.path + "_back");
                this.add(this.lmp);
            };
            return ExtraElemDecor;
        }(Phaser.Group));
        Client.ExtraElemDecor = ExtraElemDecor;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ExtraMore = (function (_super) {
            __extends(ExtraMore, _super);
            function ExtraMore(game, x, y) {
                _super.call(this, game);
                this.game = game;
                this.x = x;
                this.y = y;
                this.createGraphics();
                this.startAnim();
            }
            ExtraMore.prototype.createGraphics = function () {
                var _this = this;
                this.more = new Client.GlowObject(this.game, 0, 0, 'ExtraMore', 'back.png', this.onClick, this);
                this.add(this.more);
                this.anim = new Phaser.Sprite(this.game, 0, 0, 'ExtraMore');
                this.anim.anchor.set(0.5);
                this.add(this.anim);
                this.glowEmitter = this.game.add.emitter(20, 0, 100);
                this.add(this.glowEmitter);
                this.glowEmitter.makeParticles('preroll', 'particle_glow.png');
                this.glowEmitter.setAlpha(1, 0, 3000);
                this.glowEmitter.gravity = -10;
                this.glowEmitter.minParticleScale = 0.5;
                this.glowEmitter.maxParticleScale = 1;
                var A0 = this.game.add.tween(this).to({}, 100, Phaser.Easing.Linear.None, false, 2900);
                A0.onComplete.add(function () {
                    _this.glowEmitter.start(true, 1500, null, 25);
                    console.log('flow');
                }, this);
                A0.chain(A0);
                A0.start();
            };
            ExtraMore.prototype.startAnim = function () {
                var animArr = [];
                for (var i = 0; i < 24; i++) {
                    if (i < 3) {
                        animArr.push("e" + i + ".png");
                    }
                    else {
                        animArr.push("e" + 0 + ".png");
                    }
                }
                this.anim.visible = true;
                this.anim.animations.add('Animation', animArr, 8, true);
                this.anim.play('Animation');
            };
            ExtraMore.prototype.onOver = function (target) {
                this.game.tweens.removeFrom(target);
                this.game.add.tween(target.scale).to({ x: 1.05, y: 1.05 }, 100, Phaser.Easing.Linear.None, true);
            };
            ExtraMore.prototype.onOut = function (target) {
                this.game.tweens.removeFrom(target);
                this.game.add.tween(target.scale).to({ x: 1, y: 1 }, 100, Phaser.Easing.Linear.None, true);
            };
            ExtraMore.prototype.onClick = function (context) {
                if (context === void 0) { context = null; }
                if (Client.Config.EXTRA_MORE.url != '') {
                    var CCR = Client.Config.EXTRA_MORE.url;
                    var url = document.referrer;
                    var l = document.createElement('a');
                    l.href = url;
                    var loc = l;
                    var promoURL = CCR + "&utm_source=" + loc.hostname + "&utm_campaign=" + Client.Config.MORE_CONFIG.gameID + "&utm_medium=referral&utm_content=main_more_games";
                    window.open(promoURL);
                }
                else {
                    Client.Utils.moreUrl('main_more_games');
                }
            };
            return ExtraMore;
        }(Phaser.Group));
        Client.ExtraMore = ExtraMore;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ExtraSelectBtn = (function (_super) {
            __extends(ExtraSelectBtn, _super);
            function ExtraSelectBtn(game, isActive) {
                _super.call(this, game);
                this.game = game;
                this.isActive = isActive;
                this.createGraphics();
                this.startAnim();
            }
            ExtraSelectBtn.prototype.createGraphics = function () {
            };
            ExtraSelectBtn.prototype.startAnim = function () {
            };
            ExtraSelectBtn.prototype.onOver = function (target) {
                this.game.tweens.removeFrom(target);
                this.game.add.tween(target.scale).to({ x: 1.05, y: 1.05 }, 100, Phaser.Easing.Linear.None, true);
            };
            ExtraSelectBtn.prototype.onOut = function (target) {
                this.game.tweens.removeFrom(target);
                this.game.add.tween(target.scale).to({ x: 1, y: 1 }, 100, Phaser.Easing.Linear.None, true);
            };
            ExtraSelectBtn.prototype.onClick = function (target) {
                Client.Utils.moreUrl('main_more_games');
            };
            return ExtraSelectBtn;
        }(Phaser.Group));
        Client.ExtraSelectBtn = ExtraSelectBtn;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ExtraStartLogo = (function (_super) {
            __extends(ExtraStartLogo, _super);
            function ExtraStartLogo(game) {
                _super.call(this, game);
                this.game = game;
                this.createGraphics();
            }
            ExtraStartLogo.prototype.createGraphics = function () {
                this.add(new Phaser.Image(this.game, 0, 0, 'GameObjects', 'start_logo.png'));
                this.add(new Client.Lights(this.game, 3, 'start_logo_tinsel_', 'GameObjects'));
            };
            return ExtraStartLogo;
        }(Phaser.Group));
        Client.ExtraStartLogo = ExtraStartLogo;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var MoreInDress = (function (_super) {
            __extends(MoreInDress, _super);
            function MoreInDress(game, ID) {
                _super.call(this, game);
                this.game = game;
                this.ID = ID;
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.createGraphics();
                    this.startAnim();
                }
                else {
                    this.destroy(true);
                }
            }
            MoreInDress.prototype.createGraphics = function () {
                this.more = new Client.GlowObject(this.game, 960 / 2 - 480, 720 / 2, "MoreInDress", "dress_more_" + this.ID + "_frame_0.png", function () { Client.Utils.moreUrl('ingame_more_games'); }, this);
                this.more.setGlow = false;
                this.add(this.more);
                this.anim = new Phaser.Sprite(this.game, 0, 0, "MoreInDress");
                this.add(this.anim);
                this.anim.visible = false;
                this.anim.inputEnabled = true;
                this.anim.input.pixelPerfectClick = this.anim.input.pixelPerfectOver = true;
                this.anim.input.pixelPerfectAlpha = 10;
                this.anim.input.useHandCursor = true;
                this.anim.events.onInputDown.add(this.onClick, this);
                var animArr = [];
                for (var i = 0; i < 24; i++) {
                    if (i < 6) {
                        animArr.push("dress_more_" + this.ID + "_frame_" + i + ".png");
                    }
                    else {
                        animArr.push("dress_more_" + this.ID + "_frame_" + 0 + ".png");
                    }
                }
                this.anim.animations.add('Animation', animArr, 12, true);
                this.anim.play('Animation');
            };
            MoreInDress.prototype.onClick = function (target) {
                Client.Utils.moreUrl('main_more_games');
            };
            MoreInDress.prototype.startAnim = function () {
                var _this = this;
                var A0 = this.game.add.tween(this.more).to({ x: 960 / 2 }, 1200, Phaser.Easing.Linear.None, false);
                A0.onComplete.addOnce(function () {
                    _this.anim.visible = true;
                }, this);
                var A1 = this.game.add.tween(this).to({}, 2200, Phaser.Easing.Linear.None, false);
                A1.onComplete.addOnce(function () {
                    _this.anim.visible = false;
                }, this);
                var A2 = this.game.add.tween(this.more).to({ x: 960 / 2 - 480 }, 1200, Phaser.Easing.Linear.None, false);
                var A3 = this.game.add.tween(this).to({}, 5000, Phaser.Easing.Linear.None, false);
                A0.chain(A1);
                A1.chain(A2);
                A2.chain(A3);
                A3.chain(A0);
                A0.start();
            };
            return MoreInDress;
        }(Phaser.Group));
        Client.MoreInDress = MoreInDress;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Main = (function (_super) {
            __extends(Main, _super);
            function Main() {
                _super.apply(this, arguments);
                this.waitScreenID = -1;
            }
            Main.prototype.create = function () {
                Client.Globals.GAME = this.game;
                Client.Globals.MAIN = this;
                this.MM = new Client.MusicManager();
                if (Client.Config.VERSION_ID == 'GGG' || Client.Config.VERSION_ID == 'DUW') {
                    Client.Config.BANNERS = true;
                    if (Client.Config.VERSION_ID == 'DUW') {
                        Client.Config.EXTRA_MORE.enabled = false;
                        Client.Config.AD_PARAM.lock = true;
                    }
                }
                Client.Event.onPageEvent = new Phaser.Signal();
                Client.Event.onScreenEvent = new Phaser.Signal();
                Client.Event.onItemsEvent = new Phaser.Signal();
                Client.Event.onAdEvent = new Phaser.Signal();
                Client.Event.onDollEvent = new Phaser.Signal();
                Client.Event.onScreenEvent.add(this.screenEvent, this);
                Client.Event.onItemsEvent.add(this.itemEvent, this);
                Client.Event.onAdEvent.add(this.adEvent, this);
                if (Client.Config.VERSION_ID == 'FULL' || Client.Config.VERSION_ID == 'NB') {
                    Client.Globals.AD_SCREENS = [2, 3];
                    Client.Config.AD_PARAM.max = 3;
                }
                if (Client.Config.VERSION_ID == 'NB_1AD' || Client.Config.VERSION_ID == 'DUW') {
                    Client.Config.AD_PARAM.lock = true;
                    Client.Globals.AD_SCREENS = [2];
                    Client.Config.AD_PARAM.max = 1;
                }
                if (Client.Config.VERSION_ID == 'NOAD' || Client.Config.VERSION_ID == 'GGG' || Client.Config.VERSION_ID == 'GD') {
                    Client.Globals.AD_SCREENS = [];
                    Client.Config.AD_PARAM.max = 0;
                }
                if (Client.Config.SAVER.type) {
                    Client.Globals.DELAY = 750;
                }
                this.reload();
                this.GUI = new Client.GuiFrame(this.game);
                this.GUI.pendingDestroy = true;
                this.saverContainer = new Phaser.Group(this.game);
                this.saverContainer.pendingDestroy = true;
                this.switchScreen();
            };
            Main.prototype.reload = function () {
                Client.Globals.BACK_ID = -1;
                Client.Globals.NextScreenID = -1;
                Client.Globals.ANIM_ID = -1;
                Client.Globals.DRESS_ID = -1;
                Client.Config.AD_PARAM.cnt = 0;
                if (Client.Config.VERSION_ID == 'NB_1AD' || Client.Config.VERSION_ID == 'DUW') {
                    Client.Config.AD_PARAM.lock = true;
                }
                Client.Globals.PATH = -1;
                Client.Globals.SCORE = [];
                Client.Globals.DONE = [false, false];
                Client.Globals.DOLLS_VIEW = Client.Utils.getDollData();
                Client.Globals.MAKET = [-1, -1, -1];
                this.resetGirls();
            };
            Main.prototype.switchScreen = function (id) {
                if (id === void 0) { id = 0; }
                this.game.tweens.removeAll();
                this.game.time.events.removeAll();
                this.waitScreenID = id;
                this.showSaver('open');
            };
            Main.prototype.setGUI = function (view) {
                this.GUI.destroy(true, false);
                this.GUI = new Client.GuiFrame(this.game);
                this.GUI.showPromo(false);
                this.GUI.setView(view);
                if (Client.Config.EXTRA_MORE.enabled) {
                    if (this.EM) {
                        this.EM.destroy();
                    }
                    this.EM = new Client.ExtraMore(this.game, Client.Config.EXTRA_MORE.x, Client.Config.EXTRA_MORE.y);
                }
            };
            Main.prototype.showSaver = function (phase) {
                this.saverContainer.destroy(true, false);
                this.saverContainer = new Phaser.Group(this.game);
                this.saverScreen = new Client.SaverScreen(this.game, phase);
                this.saverContainer.add(this.saverScreen);
            };
            Main.prototype.itemEvent = function (params) {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    if (Client.Globals.GIRL[i]) {
                        Client.Globals.GIRL[i].setView();
                    }
                }
            };
            Main.prototype.resetGirls = function () {
                Client.Globals.GIRL_ID = -1;
                Client.Globals.CASE = new Client.DressCase(this.game);
                Client.Globals.CASE.x = 1200;
                Client.Globals.CASE.setView(0, 0);
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    Client.Globals.GIRL[i].x = 1200;
                    Client.Globals.GIRL[i].y = 0;
                    Client.Globals.GIRL[i].scale.set(1);
                    Client.Globals.GIRL[i].mask = null;
                    Client.Globals.GIRL[i].filters = null;
                    Client.Globals.GIRL[i].angle = 0;
                    Client.Globals.GIRL[i].setView();
                    this.game.tweens.removeFrom(Client.Globals.GIRL[i]);
                    this.game.tweens.removeFrom(Client.Globals.GIRL[i].scale);
                }
            };
            Main.prototype.adEvent = function (param) {
                if (param.type == 'music') {
                    if (param.action == 'on') {
                        this.game.sound.mute = false;
                    }
                    if (param.action == 'off') {
                        this.game.sound.mute = true;
                    }
                }
            };
            Main.prototype.screenEvent = function (param) {
                if (param.type == 'music') {
                    if (param.action == 'on') {
                        this.MM.onMusic(true);
                    }
                    if (param.action == 'off') {
                        this.MM.onMusic(false);
                    }
                }
                if (param.command == 'reload') {
                    this.reload();
                }
                if (param.type == 'GUI') {
                    if (param.action == 'onClick') {
                        if (param.name == 'play' || param.name == 'next' || param.name == 'replay') {
                            this.switchScreen(Client.Globals.NextScreenID);
                        }
                    }
                    if (param.action == 'setView') {
                        this.setGUI(param.view);
                        if (param.view == 'end') {
                            this.GUI.showPromo(true, param.xy);
                        }
                    }
                    if (param.action == 'showPromo') {
                        this.GUI.showPromo(true);
                    }
                }
                if (param.type == 'case') {
                    if (param.action == 'hide') {
                        try {
                            Client.Globals.CASE.hidden(param.elems);
                        }
                        catch (e) { }
                    }
                }
                if (param.type == 'switchScreen') {
                    this.game.canvas.style.cursor = 'auto';
                    if (this.SM) {
                        this.SM.destroyMe();
                    }
                    if (this.waitScreenID == 0) {
                        this.SM = new Client.StartScreen(this.game, this.waitScreenID);
                    }
                    if (this.waitScreenID == 1) {
                        this.SM = new Client.AnimScreen(this.game, this.waitScreenID);
                    }
                    if (this.waitScreenID == 2) {
                        this.SM = new Client.DressScreen(this.game, this.waitScreenID);
                    }
                    if (this.waitScreenID == 3) {
                        this.SM = new Client.EndScreen(this.game, this.waitScreenID);
                    }
                    this.SM.init();
                    if (Client.Globals.AD_SCREENS.indexOf(this.waitScreenID) != -1) {
                        Client.Config.PREAD ? new Client.PreAD(this.game) : Client.Utils.showAD();
                    }
                    this.showSaver('close');
                }
            };
            return Main;
        }(Phaser.State));
        Client.Main = Main;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var Butterfly = (function (_super) {
    __extends(Butterfly, _super);
    function Butterfly(game, x, y, key, frame) {
        _super.call(this, game, x, y, 'Particles', ['butterfly_0.png', 'butterfly_1.png']);
        this.game = game;
        this.frameName = "butterfly_0.png";
        this.elapsedTime = 0;
    }
    Butterfly.prototype.update = function () {
        _super.prototype.update.call(this);
        this.elapsedTime++;
        if (this.elapsedTime <= 10) {
            this.frameName = "butterfly_0.png";
        }
        else if (this.elapsedTime <= 20) {
            this.frameName = "butterfly_1.png";
        }
        else {
            this.elapsedTime = 0;
            this.frameName = "butterfly_0.png";
        }
    };
    return Butterfly;
}(Phaser.Particle));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var FlashAnim = (function (_super) {
            __extends(FlashAnim, _super);
            function FlashAnim(game, pref, elems, kit, atlas) {
                if (elems === void 0) { elems = 1; }
                if (kit === void 0) { kit = 1; }
                if (atlas === void 0) { atlas = 'Particles'; }
                _super.call(this, game);
                this.flash = [];
                this.lock = true;
                this.cnt = 0;
                this.game = game;
                this.pref = pref;
                this.elems = elems;
                this.kit = kit;
                this.atlas = atlas;
                this.createGraphics();
            }
            FlashAnim.prototype.createGraphics = function () {
                for (var j = 0; j < this.kit; j++) {
                    for (var i = 0; i < this.elems; i++) {
                        var pr = this.elems > 1 ? "_" + i : '';
                        this.flash.push(new Phaser.Image(this.game, 0, 0, this.atlas, "" + this.pref + pr + ".png"));
                        this.flash[i].alpha = 0;
                        this.add(this.flash[i]);
                    }
                }
                this.lock = false;
            };
            FlashAnim.prototype.update = function () {
                _super.prototype.update.call(this);
                if (!this.lock) {
                    this.cnt++;
                    if (this.cnt > Math.random() * 200) {
                        for (var i = 0; i < this.flash.length; i++) {
                            this.flash[i].position.set(Math.random() * 960, Math.random() * 720);
                            this.flash[i].scale.set(Math.random() * 0.5 + 0.5);
                            this.flash[i].alpha = 1;
                            this.game.add.tween(this.flash[i]).to({ alpha: 0 }, 250, Phaser.Easing.Linear.None, true, Math.random() * 500 * i);
                        }
                        this.cnt = 0;
                    }
                }
            };
            return FlashAnim;
        }(Phaser.Group));
        Client.FlashAnim = FlashAnim;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Lamps = (function (_super) {
            __extends(Lamps, _super);
            function Lamps(game) {
                _super.call(this, game);
                this.flash = [];
                this.game = game;
                this.createGraphics();
                this.startAnim();
            }
            Lamps.prototype.createGraphics = function () {
                this.body = new Phaser.Image(this.game, 0, 0, 'Lamps', 'lamp_back.png');
                this.add(this.body);
                for (var i = 0; i < 22; i++) {
                    this.flash.push(new Phaser.Image(this.game, 0, 0, 'Lamps', "l" + i + ".png"));
                    this.flash[i].alpha = 0;
                    this.add(this.flash[i]);
                }
            };
            Lamps.prototype.startAnim = function () {
                for (var i = 0; i < 22; i++) {
                    this.game.add.tween(this.flash[i]).to({ alpha: 1 }, Math.random() * 200 + 200, Phaser.Easing.Linear.None, true, Math.random() * 500, Number.MAX_VALUE, true);
                }
            };
            return Lamps;
        }(Phaser.Group));
        Client.Lamps = Lamps;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Lights = (function (_super) {
            __extends(Lights, _super);
            function Lights(game, maxElem, image, atlas) {
                if (image === void 0) { image = 'lights_'; }
                if (atlas === void 0) { atlas = 'GameObjects'; }
                _super.call(this, game);
                this.lights = [];
                this.game = game;
                this.maxElem = maxElem;
                this.image = image;
                this.atlas = atlas;
                this.createGraphics();
                this.startAnim();
            }
            Lights.prototype.createGraphics = function () {
                for (var i = 0; i < this.maxElem; i++) {
                    this.lights.push(new Phaser.Image(this.game, 0, 0, this.atlas, "" + this.image + i + ".png"));
                    this.lights[i].alpha = 0;
                    this.add(this.lights[i]);
                }
            };
            Lights.prototype.startAnim = function () {
                for (var i = 0; i < this.maxElem; i++) {
                    this.game.add.tween(this.lights[i]).to({ alpha: 1 }, Math.random() * 200 + 300, Phaser.Easing.Linear.None, true, Math.random() * 500, Number.MAX_VALUE, true);
                }
            };
            return Lights;
        }(Phaser.Group));
        Client.Lights = Lights;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var MoreSprite = (function (_super) {
            __extends(MoreSprite, _super);
            function MoreSprite(game, pref, frames, FPS, atlas) {
                _super.call(this, game);
                this.game = game;
                this.pref = pref;
                this.frames = frames;
                this.FPS = FPS;
                this.atlas = atlas;
                this.createGraphics();
                this.startAnim();
            }
            MoreSprite.prototype.createGraphics = function () {
                this.anim = new Phaser.Sprite(this.game, 0, 0, this.atlas);
                this.add(this.anim);
                this.anim.inputEnabled = true;
                this.anim.input.pixelPerfectClick = this.anim.input.pixelPerfectOver = true;
                this.anim.input.pixelPerfectAlpha = 10;
                this.anim.input.useHandCursor = true;
                this.anim.events.onInputDown.add(this.onClick, this);
            };
            MoreSprite.prototype.startAnim = function () {
                var animArr = [];
                for (var i = 0; i < this.frames; i++) {
                    animArr.push(this.pref + "_" + i + ".png");
                }
                this.anim.animations.add('Animation', animArr, this.FPS, true);
                this.anim.play('Animation');
            };
            MoreSprite.prototype.onClick = function (target) {
                Client.Utils.moreUrl('ingame_more_games');
            };
            return MoreSprite;
        }(Phaser.Group));
        Client.MoreSprite = MoreSprite;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Particles = (function (_super) {
            __extends(Particles, _super);
            function Particles(game, path, type, quantity, atlas, maxPart) {
                if (type === void 0) { type = 'confetti'; }
                if (quantity === void 0) { quantity = 1; }
                if (atlas === void 0) { atlas = 'Particles'; }
                if (maxPart === void 0) { maxPart = 50; }
                _super.call(this, game);
                this.particles = [];
                this.game = game;
                for (var i = 0; i < quantity; i++) {
                    this.particles.push(new Phaser.Particles.Arcade.Emitter(this.game, this.game.world.centerX, -50, maxPart));
                    if (type != 'butterfly') {
                        this.particles[i].makeParticles(atlas, quantity != 1 ? path + "_" + i + ".png" : path + ".png");
                    }
                    else {
                        this.particles[i].particleClass = Butterfly;
                        this.particles[i].makeParticles('Particles');
                        this.particles[i].x = 0;
                        this.particles[i].y = 720;
                        this.particles[i].setYSpeed(-50, -200);
                        this.particles[i].setXSpeed(50, 250);
                        this.particles[i].minParticleScale = 0.5;
                        this.particles[i].maxParticleScale = 1;
                        this.particles[i].setRotation(0, 0);
                        this.particles[i].width = 960;
                        this.particles[i].gravity = -150;
                        this.particles[i].flow(3000, 500, 2, -1);
                    }
                    if (type == 'leaf') {
                        this.particles[i].minParticleSpeed.setTo(-300, 30);
                        this.particles[i].maxParticleSpeed.setTo(300, 100);
                        this.particles[i].minParticleScale = 0.4;
                        this.particles[i].maxParticleScale = 0.9;
                        this.particles[i].gravity = 150;
                        this.particles[i].width = this.game.world.width * 1.5;
                        this.particles[i].flow(3000, 500, 5, -1);
                    }
                    if (type == 'confetti') {
                        this.particles[i].x = 480;
                        this.particles[i].y = -100;
                        this.particles[i].minParticleSpeed.setTo(-30, 30);
                        this.particles[i].maxParticleSpeed.setTo(10, 100);
                        this.particles[i].minParticleScale = 0.4;
                        this.particles[i].maxParticleScale = 0.9;
                        this.particles[i].gravity = 50;
                        this.particles[i].width = 960;
                        this.particles[i].flow(5500, 500, 10, -1);
                    }
                    if (type == 'bubble') {
                        this.particles[i].x = 480;
                        this.particles[i].y = 820;
                        this.particles[i].minParticleSpeed.setTo(-30, -30);
                        this.particles[i].maxParticleSpeed.setTo(0, -100);
                        this.particles[i].minParticleScale = 0.3;
                        this.particles[i].maxParticleScale = 0.95;
                        this.particles[i].setRotation(0, 0);
                        this.particles[i].gravity = -100;
                        this.particles[i].width = 960;
                        this.particles[i].flow(7000, 500, 2, -1);
                    }
                    if (type == 'rain') {
                        this.particles[i].angle = -30;
                        this.particles[i].x = 240;
                        this.particles[i].y = -100;
                        this.particles[i].setYSpeed(800, 1300);
                        this.particles[i].setXSpeed(-5, 5);
                        this.particles[i].minParticleScale = 0.4;
                        this.particles[i].maxParticleScale = 1;
                        this.particles[i].setRotation(0, 0);
                        this.particles[i].width = 960 * 2;
                        this.particles[i].flow(1000, 200, 50, -1);
                    }
                    if (type == 'star') {
                        this.particles[i].x = 480;
                        this.particles[i].y = -100;
                        this.particles[i].setYSpeed(800, 1300);
                        this.particles[i].setXSpeed(0, 0);
                        this.particles[i].minParticleScale = 0.7;
                        this.particles[i].maxParticleScale = 1;
                        this.particles[i].width = 960;
                        this.particles[i].flow(800, 50, 70, -1);
                    }
                    if (type == 'rose') {
                        this.particles[i].minParticleSpeed.setTo(-300, 30);
                        this.particles[i].maxParticleSpeed.setTo(300, 100);
                        this.particles[i].minParticleScale = 0.4;
                        this.particles[i].maxParticleScale = 0.9;
                        this.particles[i].gravity = 150;
                        this.particles[i].width = this.game.world.width * 1.5;
                        this.particles[i].flow(3000, 500, 5, -1);
                    }
                    if (type == 'snow') {
                        this.particles[i].minParticleSpeed.setTo(-300, 30);
                        this.particles[i].maxParticleSpeed.setTo(300, 100);
                        this.particles[i].minParticleScale = 0.4;
                        this.particles[i].maxParticleScale = 0.8;
                        this.particles[i].gravity = 140;
                        this.particles[i].width = this.game.world.width * 1.5;
                        this.particles[i].flow(3000, 500, 5, -1);
                    }
                    if (type == 'tinsel') {
                        this.particles[i].minParticleSpeed.setTo(-100, 50);
                        this.particles[i].maxParticleSpeed.setTo(100, 150);
                        this.particles[i].minParticleScale = 0.8;
                        this.particles[i].maxParticleScale = 1;
                        this.particles[i].gravity = 150;
                        this.particles[i].width = this.game.world.width * 1.5;
                        this.particles[i].flow(3000, 200, 50, -1);
                    }
                    this.add(this.particles[i]);
                }
            }
            return Particles;
        }(Phaser.Group));
        Client.Particles = Particles;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var SingleLamp = (function (_super) {
            __extends(SingleLamp, _super);
            function SingleLamp(game, atlas, path) {
                _super.call(this, game);
                this.game = game;
                this.atlas = atlas;
                this.path = path;
                this.createGraphics();
                this.startAnim();
            }
            SingleLamp.prototype.createGraphics = function () {
                this.img = new Phaser.Image(this.game, 0, 0, this.atlas, this.path + ".png");
                this.img.alpha = 0;
                this.add(this.img);
            };
            SingleLamp.prototype.startAnim = function () {
                this.game.add.tween(this.img).to({ alpha: 1 }, Math.random() * 200 + 200, Phaser.Easing.Linear.None, true, Math.random() * 500, Number.MAX_VALUE, true);
            };
            return SingleLamp;
        }(Phaser.Group));
        Client.SingleLamp = SingleLamp;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GameLogo = (function (_super) {
            __extends(GameLogo, _super);
            function GameLogo(game, atlas, type, frames) {
                if (atlas === void 0) { atlas = 'Saver'; }
                if (type === void 0) { type = null; }
                if (frames === void 0) { frames = 3; }
                _super.call(this, game);
                this.game = game;
                if (type == 'default') {
                    this.logo = new Phaser.Image(this.game, 480, 360, 'GL');
                    this.logo.anchor.set(0.5);
                    this.add(this.logo);
                }
                if (type == 'anim') {
                    this.logo = new Phaser.Sprite(this.game, 480, 360, atlas);
                    this.logo.anchor.set(0.5);
                    this.add(this.logo);
                }
                var animArr = [];
                for (var i = 0; i < frames; i++) {
                    animArr.push("GameLogo_" + i + ".png");
                }
                this.logo.animations.add('Animation', animArr, 12, true);
                this.logo.play('Animation');
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.logo.inputEnabled = true;
                    this.logo.input.pixelPerfectClick = true;
                    this.logo.input.pixelPerfectOver = true;
                    this.logo.input.pixelPerfectAlpha = 10;
                    this.logo.input.useHandCursor = true;
                    this.logo.events.onInputDown.add(this.onClick, this);
                }
            }
            GameLogo.prototype.onClick = function (target) { Client.Utils.moreUrl('main_logo'); };
            return GameLogo;
        }(Phaser.Group));
        Client.GameLogo = GameLogo;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GlowObject = (function (_super) {
            __extends(GlowObject, _super);
            function GlowObject(game, x, y, atlas, frame, callback, context, name, glowSize, active, glow, glowColor) {
                if (callback === void 0) { callback = null; }
                if (context === void 0) { context = null; }
                if (name === void 0) { name = null; }
                if (glowSize === void 0) { glowSize = 0.05; }
                if (active === void 0) { active = true; }
                if (glow === void 0) { glow = true; }
                if (glowColor === void 0) { glowColor = [0xFF, 0xFF, 0xFF]; }
                _super.call(this, game);
                this.eventType = 'glowObject';
                this.scaleOver = 1;
                this.glowAlways = false;
                this.isPulse = false;
                this.directionPulse = 0.02;
                this.glowColor = [];
                this.ANCHOR = [0.5, 0.5];
                this.game = game;
                this.glowSize = glowSize;
                this.glowColor = glowColor;
                this.mainImage = new Phaser.Image(game, 0, 0, atlas, frame);
                this.add(this.mainImage);
                this.mainImage.anchor.setTo(this.ANCHOR[0], this.ANCHOR[1]);
                this.clickCallback = callback;
                this.clickContext = context;
                this.name = name;
                this.setActive = active;
                this.setGlow = glow;
                this.x = x;
                this.y = y;
            }
            GlowObject.prototype.setAnchor = function (ANCHOR) {
                this.ANCHOR = ANCHOR;
                this.mainImage.anchor.setTo(ANCHOR[0], ANCHOR[1]);
                if (this.backImage) {
                    this.backImage.anchor.setTo(ANCHOR[0], ANCHOR[1]);
                }
            };
            Object.defineProperty(GlowObject.prototype, "setActive", {
                set: function (mode) {
                    this.isActive = mode;
                    this.mainImage.events.destroy();
                    this.mainImage.inputEnabled = this.isActive;
                    this.mainImage.input.pixelPerfectClick = this.mainImage.input.pixelPerfectOver = true;
                    this.mainImage.input.pixelPerfectAlpha = 10;
                    this.mainImage.input.useHandCursor = this.isActive;
                    if (this.isActive) {
                        this.mainImage.events.onInputOver.add(this.onOver, this);
                        this.mainImage.events.onInputOut.add(this.onOut, this);
                        this.mainImage.events.onInputDown.add(this.onClick, this);
                        this.mainImage.name = name;
                    }
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(GlowObject.prototype, "setScale", {
                set: function (value) {
                    this.scaleOver = value;
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(GlowObject.prototype, "setGlow", {
                set: function (mode) {
                    this.isGlow = mode;
                    if (this.backImage)
                        this.backImage.visible = mode;
                },
                enumerable: true,
                configurable: true
            });
            GlowObject.prototype.setStaticGlow = function () {
                this.isActive = false;
                this.isGlow = true;
                this.createBack();
                this.glowAlways = true;
                this.backImage.visible = true;
            };
            GlowObject.prototype.delStaticGlow = function () {
                this.isActive = false;
                this.isGlow = false;
                this.createBack();
                this.glowAlways = false;
                this.backImage.visible = false;
            };
            Object.defineProperty(GlowObject.prototype, "setPulse", {
                set: function (mode) {
                    this.createBack();
                    this.isPulse = mode;
                    this.glowAlways = mode;
                    this.backImage.visible = mode;
                },
                enumerable: true,
                configurable: true
            });
            GlowObject.prototype.update = function () {
                _super.prototype.update.call(this);
                if (this.isPulse && this.backImage) {
                    this.backImage.alpha += this.directionPulse;
                    if (this.backImage.alpha > 0.98) {
                        this.backImage.alpha = 0.98;
                        this.directionPulse = -this.directionPulse;
                    }
                    else if (this.backImage.alpha < 0.02) {
                        this.backImage.alpha = 0.02;
                        this.directionPulse = -this.directionPulse;
                    }
                }
                if (this.backImage && this.scaleOver != 1) {
                    this.backImage.scale = this.mainImage.scale;
                }
            };
            GlowObject.prototype.onOver = function () {
                if (this.isGlow) {
                    if (!this.backImage) {
                        this.createBack();
                    }
                    this.backImage.visible = true;
                }
                if (this.scaleOver != 1) {
                    this.game.add.tween(this.mainImage.scale).to({ x: this.scaleOver, y: this.scaleOver }, 100, Phaser.Easing.Linear.None, true);
                }
            };
            GlowObject.prototype.createBack = function () {
                if (!this.backImage) {
                    this.mainImage.anchor.setTo(0, 0);
                    var bmd = this.game.make.bitmapData();
                    bmd.load(this.mainImage);
                    bmd.blendSourceAtop();
                    bmd.fill(this.glowColor[0], this.glowColor[1], this.glowColor[2]);
                    this.backImage = new Phaser.Image(this.game, 0, 0, bmd);
                    this.add(this.backImage);
                    this.backImage.filters = [new Client.GlowFilter(this.game, this.glowSize)];
                    this.setChildIndex(this.backImage, 0);
                    this.mainImage.anchor.setTo(this.ANCHOR[0], this.ANCHOR[1]);
                    this.backImage.anchor.setTo(this.ANCHOR[0], this.ANCHOR[1]);
                    bmd = null;
                }
            };
            Object.defineProperty(GlowObject.prototype, "setGlowSize", {
                set: function (value) {
                    this.glowSize = value;
                    this.backImage = null;
                    this.createBack();
                },
                enumerable: true,
                configurable: true
            });
            GlowObject.prototype.onOut = function () {
                if (this.backImage) {
                    this.backImage.visible = this.glowAlways;
                }
                if (this.scaleOver != 1) {
                    this.game.add.tween(this.mainImage.scale).to({ x: 1, y: 1 }, 100, Phaser.Easing.Linear.None, true);
                }
            };
            GlowObject.prototype.onClick = function () {
                if (this.clickCallback) {
                    this.clickCallback(this.clickContext);
                }
                else {
                    Client.Event.onItemsEvent.dispatch({ type: this.eventType, id: this.name });
                }
                if (this.glowAlways) {
                    this.backImage.visible = true;
                }
            };
            Object.defineProperty(GlowObject.prototype, "setGlowColor", {
                set: function (arr) {
                    this.glowColor = arr;
                    this.backImage = null;
                    this.createBack();
                },
                enumerable: true,
                configurable: true
            });
            return GlowObject;
        }(Phaser.Group));
        Client.GlowObject = GlowObject;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GuiFrame = (function (_super) {
            __extends(GuiFrame, _super);
            function GuiFrame(game) {
                _super.call(this, game);
                this.game = game;
                if (Client.Config.PUBLISHER == 'D') {
                    GuiFrame.BUTTONS.play.rotate = true;
                    GuiFrame.BUTTONS.play.images = ['playBtn_normal.png', 'playBtn_normal.png', 'playBtn_normal.png'];
                    GuiFrame.BUTTONS.next.rotate = true;
                    GuiFrame.BUTTONS.next.images = ['nextBtn_normal.png', 'nextBtn_normal.png', 'nextBtn_normal.png'];
                    GuiFrame.BUTTONS.replay.rotate = true;
                    GuiFrame.BUTTONS.replay.images = ['replayBtn_normal.png', 'replayBtn_normal.png', 'replayBtn_normal.png'];
                    GuiFrame.BUTTONS.more.rotate = true;
                    GuiFrame.BUTTONS.more.images = ['moreBtn_normal.png', 'moreBtn_normal.png', 'moreBtn_normal.png'];
                    GuiFrame.BUTTONS.soundOn.rotate = true;
                    GuiFrame.BUTTONS.soundOn.images = ['musicBtn_ON_normal.png', 'musicBtn_ON_normal.png', 'musicBtn_ON_normal.png'];
                    GuiFrame.BUTTONS.soundOff.rotate = true;
                    GuiFrame.BUTTONS.soundOff.images = ['musicBtn_OFF_normal.png', 'musicBtn_OFF_normal.png', 'musicBtn_OFF_normal.png'];
                    GuiFrame.BUTTONS.dressup.x = 115;
                    GuiFrame.BUTTONS.soundOn.x = 910;
                    GuiFrame.BUTTONS.soundOff.x = 910;
                }
                if (Client.Config.PUBLISHER == 'F') {
                    GuiFrame.BUTTONS.play.x = 70;
                    GuiFrame.BUTTONS.play.y = 650;
                    GuiFrame.BUTTONS.play.scale = [1, 1, 1];
                    GuiFrame.BUTTONS.next.x = 70;
                    GuiFrame.BUTTONS.next.y = 650;
                    GuiFrame.BUTTONS.next.scale = [1, 1, 1];
                    GuiFrame.BUTTONS.replay.x = 70;
                    GuiFrame.BUTTONS.replay.y = 650;
                    GuiFrame.BUTTONS.replay.scale = [1, 1, 1];
                    GuiFrame.BUTTONS.more.x = 890;
                    GuiFrame.BUTTONS.more.y = 650;
                    GuiFrame.BUTTONS.more.scale = [1, 1, 1];
                    GuiFrame.BUTTONS.dressup.x = 820;
                    GuiFrame.BUTTONS.dressup.y = 55;
                    GuiFrame.BUTTONS.dressup.scale = [1, 1.05, 1];
                    GuiFrame.BUTTONS.soundOn.x = 60;
                    GuiFrame.BUTTONS.soundOn.y = 60;
                    GuiFrame.BUTTONS.soundOn.scale = [1, 1, 1];
                    GuiFrame.BUTTONS.soundOff.x = 60;
                    GuiFrame.BUTTONS.soundOff.y = 60;
                    GuiFrame.BUTTONS.soundOff.scale = [1, 1, 1];
                    if (Client.Config.REVERS) {
                        GuiFrame.BUTTONS.dressup.x = 280 / 2;
                        GuiFrame.BUTTONS.soundOn.x = 960 - 110 / 2;
                        GuiFrame.BUTTONS.soundOff.x = 960 - 110 / 2;
                    }
                }
                if (Client.Config.PUBLISHER == 'M') {
                    GuiFrame.BUTTONS.play.x = 70;
                    GuiFrame.BUTTONS.play.y = 655;
                    GuiFrame.BUTTONS.play.rotate = true;
                    GuiFrame.BUTTONS.play.images = ['playBtn_normal.png', 'playBtn_normal.png', 'playBtn_down.png'];
                    GuiFrame.BUTTONS.next.x = 70;
                    GuiFrame.BUTTONS.next.y = 655;
                    GuiFrame.BUTTONS.next.rotate = true;
                    GuiFrame.BUTTONS.next.images = ['nextBtn_normal.png', 'nextBtn_normal.png', 'nextBtn_down.png'];
                    GuiFrame.BUTTONS.replay.x = 70;
                    GuiFrame.BUTTONS.replay.y = 655;
                    GuiFrame.BUTTONS.replay.rotate = true;
                    GuiFrame.BUTTONS.replay.images = ['replayBtn_normal.png', 'replayBtn_normal.png', 'replayBtn_down.png'];
                    GuiFrame.BUTTONS.more.x = 890;
                    GuiFrame.BUTTONS.more.y = 655;
                    GuiFrame.BUTTONS.more.rotate = true;
                    GuiFrame.BUTTONS.more.images = ['moreBtn_normal.png', 'moreBtn_normal.png', 'moreBtn_down.png'];
                    GuiFrame.BUTTONS.dressup.x = 80;
                    GuiFrame.BUTTONS.dressup.y = 80;
                    GuiFrame.BUTTONS.soundOn.x = 890;
                    GuiFrame.BUTTONS.soundOn.y = 60;
                    GuiFrame.BUTTONS.soundOn.rotate = true;
                    GuiFrame.BUTTONS.soundOn.images = ['musicBtn_ON_normal.png', 'musicBtn_ON_normal.png', 'musicBtn_ON_down.png'];
                    GuiFrame.BUTTONS.soundOff.x = 890;
                    GuiFrame.BUTTONS.soundOff.y = 60;
                    GuiFrame.BUTTONS.soundOff.rotate = true;
                    GuiFrame.BUTTONS.soundOff.images = ['musicBtn_OFF_normal.png', 'musicBtn_OFF_normal.png', 'musicBtn_OFF_down.png'];
                }
                this.buttons = [];
                for (var id in GuiFrame.BUTTONS) {
                    this.buttons[id] = this.game.add.button(GuiFrame.BUTTONS[id]['x'], GuiFrame.BUTTONS[id]['y'], 'main', this.onClick, this, GuiFrame.BUTTONS[id]['images'][1], GuiFrame.BUTTONS[id]['images'][0], GuiFrame.BUTTONS[id]['images'][2]);
                    this.add(this.buttons[id]);
                    this.buttons[id].anchor.setTo(0.5, 0.5);
                    this.buttons[id].name = id;
                    this.buttons[id].input.pixelPerfectClick = this.buttons[id].input.pixelPerfectOver = true;
                    this.buttons[id].input.pixelPerfectAlpha = 10;
                    this.buttons[id].events.onInputOver.add(this.onRollOver, this);
                    this.buttons[id].events.onInputOut.add(this.onRollOut, this);
                    this.buttons[id].events.onInputDown.add(this.onButtonDown, this);
                    this.buttons[id].scale.setTo(GuiFrame.BUTTONS[id]['scale'][0], GuiFrame.BUTTONS[id]['scale'][0]);
                }
                this.promoButtons = [];
                for (var i = 0; i < Client.Config.PROMO.length; i++) {
                    this.promoButtons[i] = this.game.add.button(Client.Config.PROMO[i]['x'], Client.Config.PROMO[i]['y'], 'main', this.onPromo, this, Client.Config.PROMO[i]['image'], Client.Config.PROMO[i]['image'], Client.Config.PROMO[i]['image']);
                    this.add(this.promoButtons[i]);
                    this.promoButtons[i].anchor.setTo(0.5, 0.5);
                    this.promoButtons[i].name = i.toString();
                    this.promoButtons[i].events.onInputOver.add(this.onPromoOver, this);
                    this.promoButtons[i].events.onInputOut.add(this.onPromoOut, this);
                }
            }
            GuiFrame.prototype.onClick = function (target) {
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'onClick', name: target.name });
                if (target.name == 'soundOn') {
                    this.buttons['soundOff'].visible = true;
                    this.buttons['soundOn'].visible = false;
                    Client.Event.onScreenEvent.dispatch({ type: 'music', action: 'off' });
                }
                if (target.name == 'soundOff') {
                    this.buttons['soundOff'].visible = false;
                    this.buttons['soundOn'].visible = true;
                    Client.Event.onScreenEvent.dispatch({ type: 'music', action: 'on' });
                }
                if (GuiFrame.BUTTONS[target.name]['more']) {
                    Client.Utils.moreUrl(GuiFrame.BUTTONS[target.name]['moreType']);
                }
            };
            GuiFrame.prototype.setView = function (set) {
                for (var id in this.buttons) {
                    this.buttons[id].visible = false;
                }
                for (var i = 0; i < GuiFrame.SETS[set].length; i++) {
                    this.buttons[GuiFrame.SETS[set][i]].visible = true;
                }
                if (Client.Config.EXTRA_MORE.enabled) {
                    this.buttons['more'].visible = false;
                }
                if (set != 'photo') {
                    if (this.buttons['soundOn'] && this.buttons['soundOff']) {
                        this.buttons['soundOn'].visible = Client.Globals.SFX;
                        this.buttons['soundOff'].visible = !Client.Globals.SFX;
                    }
                }
                else {
                    this.buttons['soundOn'].visible = false;
                    this.buttons['soundOff'].visible = false;
                }
            };
            GuiFrame.prototype.showPromo = function (mode, param) {
                if (param === void 0) { param = null; }
                for (var i = 0; i < Client.Config.PROMO.length; i++) {
                    if (Client.Config.BANNERS) {
                        this.promoButtons[i].visible = mode;
                        if (mode) {
                            this.promoButtons[i].alpha = 0;
                            this.game.add.tween(this.promoButtons[i]).to({ alpha: 1 }, 1000, Phaser.Easing.Linear.None, true);
                            if (param) {
                                console.log(param);
                                this.promoButtons[i].x = param[i][0];
                                this.promoButtons[i].y = param[i][1];
                            }
                        }
                    }
                    else {
                        this.promoButtons[i].visible = false;
                    }
                }
            };
            GuiFrame.prototype.onRollOver = function (target) {
                this.game.add.tween(target.scale).to({ x: GuiFrame.BUTTONS[target.name]['scale'][1], y: GuiFrame.BUTTONS[target.name]['scale'][1] }, 100, Phaser.Easing.Linear.None, true);
                if (GuiFrame.BUTTONS[target.name]['rotate']) {
                    var _tween1 = this.game.add.tween(target).to({ angle: 10 }, 800, Phaser.Easing.Linear.None, true);
                    var _tween2 = this.game.add.tween(target).to({ angle: -10 }, 1600, Phaser.Easing.Linear.None, false);
                    var _tween3 = this.game.add.tween(target).to({ angle: 0 }, 800, Phaser.Easing.Linear.None, false);
                    _tween1.chain(_tween2);
                    _tween2.chain(_tween3);
                    _tween3.chain(_tween1);
                }
            };
            GuiFrame.prototype.onRollOut = function (target) {
                this.game.add.tween(target.scale).to({ x: GuiFrame.BUTTONS[target.name]['scale'][0], y: GuiFrame.BUTTONS[target.name]['scale'][0] }, 100, Phaser.Easing.Linear.None, true);
                if (GuiFrame.BUTTONS[target.name]['rotate']) {
                    this.game.tweens.removeFrom(target);
                    this.game.add.tween(target).to({ angle: 0 }, 200, Phaser.Easing.Linear.None, true);
                }
            };
            GuiFrame.prototype.onButtonDown = function (target) {
                target.scale.setTo(GuiFrame.BUTTONS[target.name]['scale'][2], GuiFrame.BUTTONS[target.name]['scale'][2]);
            };
            GuiFrame.prototype.onPromoOver = function (target) {
                this.game.add.tween(target.scale).to({ x: 1.05, y: 1.05 }, 100, Phaser.Easing.Linear.None, true);
            };
            GuiFrame.prototype.onPromoOut = function (target) {
                this.game.add.tween(target.scale).to({ x: 1, y: 1 }, 100, Phaser.Easing.Linear.None, true);
            };
            GuiFrame.prototype.onPromo = function (target) {
                var url = document.referrer;
                var l = document.createElement('a');
                l.href = url;
                var loc = l;
                var promoURL = Client.Config.PROMO[target.name]['url'] + "?utm_source=" + loc.hostname + "&utm_campaign=" + Client.Config.MORE_CONFIG.gameID + "&utm_medium=referral&utm_content=crosspromo";
                window.open(promoURL);
            };
            GuiFrame.BUTTONS = {
                play: { images: ['playBtn_normal.png', 'playBtn_normal.png', 'playBtn_down.png'], x: 70, y: 650, scale: [1, 1.05, 0.95], rotate: false },
                next: { images: ['nextBtn_normal.png', 'nextBtn_normal.png', 'nextBtn_down.png'], x: 70, y: 650, scale: [1, 1.05, 0.95], rotate: false },
                replay: { images: ['replayBtn_normal.png', 'replayBtn_normal.png', 'replayBtn_down.png'], x: 80, y: 650, scale: [1, 1.05, 0.95], rotate: false },
                more: { images: ['moreBtn_normal.png', 'moreBtn_normal.png', 'moreBtn_down.png'], x: 890, y: 650, scale: [1, 1.05, 0.95], more: true, moreType: 'main_more_games', rotate: false },
                dressup: { images: ['logoBtn_normal.png', 'logoBtn_normal.png', 'logoBtn_normal.png'], x: 115, y: 65, scale: [1, 1.05, 0.98], more: true, moreType: 'main_logo', rotate: false },
                soundOn: { images: ['musicBtn_ON_normal.png', 'musicBtn_ON_normal.png', 'musicBtn_ON_down.png'], x: 910, y: 50, scale: [1, 1.05, 0.95], rotate: false },
                soundOff: { images: ['musicBtn_OFF_normal.png', 'musicBtn_OFF_normal.png', 'musicBtn_OFF_down.png'], x: 910, y: 50, scale: [1, 1.05, 0.95], rotate: false }
            };
            GuiFrame.SETS = {
                start: ['play', 'soundOn', 'soundOff', 'more', 'dressup'],
                next: ['next', 'soundOn', 'soundOff', 'more', 'dressup'],
                done: ['soundOn', 'soundOff', 'more', 'dressup'],
                end: ['replay', 'soundOn', 'soundOff', 'more', 'dressup'],
                photo: ['dressup']
            };
            return GuiFrame;
        }(Phaser.Group));
        Client.GuiFrame = GuiFrame;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var More = (function (_super) {
            __extends(More, _super);
            function More(game, path, atlas, tinsel, scaling) {
                if (path === void 0) { path = null; }
                if (atlas === void 0) { atlas = 'GameObjects'; }
                if (tinsel === void 0) { tinsel = false; }
                if (scaling === void 0) { scaling = false; }
                _super.call(this, game);
                if (Client.Config.VERSION_ID == 'FULL') {
                    var pref = '';
                    if (path) {
                        pref = path + '_';
                    }
                    this.more = new Client.GlowObject(this.game, 480, 360, atlas, pref + 'more.png', function () { Client.Utils.moreUrl('ingame_more_games'); }, this);
                    if (scaling) {
                        this.more.scaleOver = 1.05;
                    }
                    this.add(this.more);
                    if (tinsel) {
                        this.tinsel = new Phaser.Image(this.game, 480, 360, atlas, pref + 'more_tinsel.png');
                        this.tinsel.anchor.set(0.5);
                        this.add(this.tinsel);
                        this.startAnim();
                    }
                }
            }
            More.prototype.setPos = function (x, y) {
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.more.x = x;
                    this.more.y = y;
                }
            };
            More.prototype.startAnim = function () {
                if (this.tinsel) {
                    this.game.add.tween(this.tinsel).to({ alpha: 0 }, 300, Phaser.Easing.Linear.None, true, 0, Number.MAX_VALUE, true);
                }
            };
            More.prototype.update = function () {
                _super.prototype.update.call(this);
                if (this.tinsel) {
                    this.tinsel.position = this.more.position;
                    this.tinsel.scale = this.more.mainImage.scale;
                }
            };
            return More;
        }(Phaser.Group));
        Client.More = More;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PromoBtn = (function (_super) {
            __extends(PromoBtn, _super);
            function PromoBtn(game, atlas, frame, ID, exp) {
                if (exp === void 0) { exp = 'png'; }
                _super.call(this, game);
                this.ID = ID;
                this.promo = new Client.GlowObject(this.game, 0, 0, atlas, frame + "." + exp, this.onPromo, this, "P" + ID);
                this.add(this.promo);
            }
            PromoBtn.prototype.onPromo = function (context) { Client.Utils.onCross(context.ID); };
            Object.defineProperty(PromoBtn.prototype, "setScalePulse", {
                set: function (flag) {
                    if (flag) {
                        this.game.add.tween(this.promo.scale).to({ x: 1.05, y: 1.05 }, 450, Phaser.Easing.Linear.None, true, Math.random() * 500, Number.MAX_VALUE, true);
                    }
                    else {
                        this.game.tweens.removeFrom(this.promo.scale);
                    }
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(PromoBtn.prototype, "setGlowColor", {
                set: function (color) {
                    this.promo.setGlowColor = color;
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(PromoBtn.prototype, "setGlowPulse", {
                set: function (flag) {
                    this.promo.setPulse = flag;
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(PromoBtn.prototype, "setGlowSize", {
                set: function (value) {
                    this.promo.setGlowSize = value;
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(PromoBtn.prototype, "setGlow", {
                set: function (mode) {
                    this.promo.setGlow = mode;
                },
                enumerable: true,
                configurable: true
            });
            Object.defineProperty(PromoBtn.prototype, "setScaleOver", {
                set: function (num) {
                    this.promo.scaleOver = num;
                },
                enumerable: true,
                configurable: true
            });
            return PromoBtn;
        }(Phaser.Group));
        Client.PromoBtn = PromoBtn;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PreAD = (function (_super) {
            __extends(PreAD, _super);
            function PreAD(game) {
                _super.call(this, game);
                this.game = game;
                this.createGraphics();
            }
            PreAD.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, 'PreAD', 'back.png');
                this.background.inputEnabled = true;
                this.add(this.background);
                var pers = new Phaser.Image(this.game, 0, 720, 'PreAD', 'pers.png');
                this.add(pers);
                var cloud = new Phaser.Image(this.game, 0, 0, 'PreAD', 'cloud.png');
                cloud.alpha = 0;
                this.add(cloud);
                this.nextBtn = new Client.GlowObject(this.game, 960 / 2, 720 / 2, 'PreAD', "btn.png", this.onNext, this);
                this.nextBtn.alpha = 0;
                this.add(this.nextBtn);
                this.game.add.tween(pers).to({ y: 0 }, 600, Phaser.Easing.Linear.None, true);
                this.game.add.tween(cloud).to({ alpha: 1 }, 600, Phaser.Easing.Linear.None, true, 600);
                this.game.add.tween(this.nextBtn).to({ alpha: 1 }, 600, Phaser.Easing.Linear.None, true, 600);
            };
            PreAD.prototype.onNext = function (context) {
                context.hideThis();
            };
            PreAD.prototype.hideThis = function () {
                Client.Utils.showAD();
                this.destroy(true);
            };
            return PreAD;
        }(Phaser.Group));
        Client.PreAD = PreAD;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var AbstractScreen = (function (_super) {
            __extends(AbstractScreen, _super);
            function AbstractScreen(game, screenID) {
                _super.call(this, game);
                this.game = game;
                this.screenID = -1;
                this.screenID = screenID;
            }
            AbstractScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy();
            };
            return AbstractScreen;
        }(Phaser.Group));
        Client.AbstractScreen = AbstractScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var AccScreen = (function (_super) {
            __extends(AccScreen, _super);
            function AccScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'dress';
                this.girlPos = [[553, 57], [565, 30]];
                this.girlScaleX = [1, 1];
                this.girlScaleY = [1, 1];
                this.pers = [];
                this.maxPers = 0;
                this.PS = [];
                this.clouds = [];
                this.maxClouds = 0;
                this.iCase = [2, 3];
                this.selectBtn = [];
                this.maxSelect = 2;
                this.lock = false;
            }
            AccScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy(true, false);
            };
            AccScreen.prototype.init = function () {
                Client.Globals.GIRL_ID = 0;
                Client.Globals.DONE[1] = true;
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            AccScreen.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, "BackDress");
                this.add(this.background);
                Client.Globals.CASE = new Client.DressCase(this.game);
                this.add(Client.Globals.CASE);
                Client.Globals.CASE.setView(this.iCase[Client.Globals.GIRL_ID], 0);
                Client.Globals.CASE.x = 0;
                Client.Globals.CASE.visible = true;
                Client.Globals.CASE.isActive = true;
                this.createDoll();
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                for (var i = 0; i < this.maxSelect; i++) {
                    this.selectBtn.push(new Client.GlowObject(this.game, 960 / 2, 720 / 2, 'GameObjects', "dress_btn_" + i + ".png", this.onSwitchGirl, this, "G" + i));
                    this.add(this.selectBtn[i]);
                    this.selectBtn[i].visible = false;
                }
                this.selectBtn[0].visible = true;
            };
            AccScreen.prototype.startAnim = function () {
            };
            AccScreen.prototype.onSwitchGirl = function (context) {
                context.setView();
            };
            AccScreen.prototype.setView = function () {
                var OLD_ID = Client.Globals.GIRL_ID;
                Client.Globals.GIRL_ID++;
                if (Client.Globals.GIRL_ID > 1) {
                    Client.Globals.GIRL_ID = 0;
                }
                Client.Globals.GIRL[OLD_ID].x = 1200;
                Client.Globals.GIRL[Client.Globals.GIRL_ID].x = this.girlPos[Client.Globals.GIRL_ID][0];
                var oldPage = Client.Globals.CASE.page;
                Client.Globals.CASE.setView(this.iCase[Client.Globals.GIRL_ID], oldPage);
                Client.Globals.GIRL[Client.Globals.GIRL_ID].setView();
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    this.selectBtn[i].visible = false;
                }
                this.selectBtn[Client.Globals.GIRL_ID].visible = true;
            };
            AccScreen.prototype.update = function () {
                _super.prototype.update.call(this);
                if (!this.lock) {
                    var score = [false, false];
                    for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                        if (Client.Globals.DOLLS_VIEW[i][0] != 0 || Client.Globals.DOLLS_VIEW[i][4] != 0 || Client.Globals.DOLLS_VIEW[i][5] != 0) {
                            score[i] = true;
                        }
                    }
                    if (Client.Utils.checkArr(score)) {
                        this.showNext();
                        this.lock = true;
                    }
                }
            };
            AccScreen.prototype.showNext = function () {
                if (!Client.Utils.checkArr(Client.Globals.DONE)) {
                    Client.Globals.NextScreenID = 2;
                }
                else {
                    Client.Globals.NextScreenID = 5;
                }
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
            };
            AccScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = 0;
                    Client.Globals.GIRL[i].y = 0;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0];
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                    Client.Globals.GIRL[i].scale.set(this.girlScaleX[i], this.girlScaleY[i]);
                    if (i != Client.Globals.GIRL_ID) {
                        Client.Globals.GIRL[i].x = 1200;
                    }
                }
            };
            return AccScreen;
        }(Client.AbstractScreen));
        Client.AccScreen = AccScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var AnimScreen = (function (_super) {
            __extends(AnimScreen, _super);
            function AnimScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'anim';
                this.backgrounds = [];
                this.maxBG = 2;
                this.pers = [];
                this.maxPers = 3;
                this.PS = ['D', 'L', 'R'];
                this.clouds = [];
                this.maxClouds = 4;
                this.elems = [];
                this.maxElems = 3;
            }
            AnimScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy();
            };
            AnimScreen.prototype.init = function () {
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            AnimScreen.prototype.createGraphics = function () {
                for (var i = 0; i < this.maxBG; i++) {
                    this.backgrounds.push(new Phaser.Image(this.game, 0, 0, this.maxBG == 1 ? "BackAnim" : "BackAnim_" + i));
                    this.add(this.backgrounds[i]);
                }
                for (var i = 0; i < this.maxElems; i++) {
                    this.elems.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_elem_" + i + ".png" : this.path + "_elem.png"));
                    this.elems[i].alpha = 0;
                    this.add(this.elems[i]);
                }
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                this.nextBtn = new Client.GlowObject(this.game, 660, 530, "GameObjects", this.path + "_btn.png", this.onNext, this);
                this.nextBtn.setGlow = false;
                this.add(this.nextBtn);
            };
            AnimScreen.prototype.startAnim = function () {
                var _this = this;
                this.backgrounds[1].visible = false;
                this.nextBtn.visible = false;
                this.nextBtn.alpha = 0;
                var A0 = this.game.add.tween(this.pers[0]).to({ x: 0, y: 0 }, 1000, Phaser.Easing.Linear.None, false, Client.Globals.DELAY + 100);
                var A1 = this.game.add.tween(this.clouds[0]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false, 100);
                var A2 = this.game.add.tween(this.clouds[1]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false, 1500);
                A2.onComplete.addOnce(function () {
                    _this.nextBtn.visible = true;
                    _this.game.add.tween(_this.nextBtn).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true).onComplete.addOnce(function () {
                        _this.game.add.tween(_this.nextBtn.scale).to({ x: 1.08, y: 1.08 }, 500, Phaser.Easing.Linear.None, true, 0, Number.MAX_VALUE, true);
                        var _tween1 = _this.game.add.tween(_this.nextBtn).to({ angle: 20 }, 500, Phaser.Easing.Linear.None, true);
                        var _tween2 = _this.game.add.tween(_this.nextBtn).to({ angle: -20 }, 1000, Phaser.Easing.Linear.None, false);
                        var _tween3 = _this.game.add.tween(_this.nextBtn).to({ angle: 0 }, 500, Phaser.Easing.Linear.None, false);
                        _tween1.chain(_tween2);
                        _tween2.chain(_tween3);
                        _tween3.chain(_tween1);
                    }, _this);
                }, this);
                A0.chain(A1);
                A1.chain(A2);
                A0.start();
            };
            AnimScreen.prototype.nextAnim = function () {
                var _this = this;
                this.nextBtn.visible = false;
                this.clouds[0].visible = false;
                this.clouds[1].visible = false;
                this.pers[0].visible = false;
                this.backgrounds[0].visible = false;
                this.backgrounds[1].visible = true;
                var A0 = this.game.add.tween(this.pers[1]).to({ x: 0, y: 0 }, 1000, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                var A1 = this.game.add.tween(this.clouds[2]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false, 100);
                A1.onComplete.addOnce(function () {
                    for (var i = 0; i < _this.maxElems; i++) {
                        _this.game.add.tween(_this.elems[i]).to({ alpha: 1 }, 500, Phaser.Easing.Linear.None, true, i == 2 ? 2000 : 1500);
                    }
                }, this);
                var A2 = this.game.add.tween(this.pers[2]).to({ x: 0, y: 0 }, 1000, Phaser.Easing.Linear.None, false, Client.Globals.DELAY + 2500);
                var A3 = this.game.add.tween(this.clouds[3]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false, 100);
                A3.onComplete.addOnce(function () {
                    Client.Globals.NextScreenID = 2;
                    Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
                }, this);
                A0.chain(A1);
                A1.chain(A2);
                A2.chain(A3);
            };
            AnimScreen.prototype.onNext = function (context) {
                context.nextAnim();
            };
            return AnimScreen;
        }(Client.AbstractScreen));
        Client.AnimScreen = AnimScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var CafeSceen = (function (_super) {
            __extends(CafeSceen, _super);
            function CafeSceen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'cafe';
                this.girlPos = [[294, 6], [873, 20], [945, 35]];
                this.girlScaleX = [1, -1, -1];
                this.girlScaleY = [1, 1, 1];
                this.pers = [];
                this.maxPers = 1;
                this.PS = ['L'];
                this.clouds = [];
                this.maxClouds = 5;
            }
            CafeSceen.prototype.init = function () {
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            CafeSceen.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, "BackCafe");
                this.add(this.background);
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                this.createDoll();
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                this.nextBtn = new Client.GlowObject(this.game, 960 / 2, 720 / 2, 'GameObjects', this.path + "_next.png", this.onNext, this);
                this.add(this.nextBtn);
                this.nextBtn.visible = false;
            };
            CafeSceen.prototype.startAnim = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    this.game.add.tween(Client.Globals.GIRL[i]).to({ x: this.girlPos[i][0] }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY);
                }
                var A0 = this.game.add.tween(this.clouds[0]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false, Client.Globals.DELAY + 1200);
                var A1 = this.game.add.tween(this.clouds[0]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, false, 3000);
                var A2 = this.game.add.tween(this.pers[0]).to({ x: 0 }, 1200, Phaser.Easing.Linear.None, false);
                var A3 = this.game.add.tween(this.clouds[1]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false);
                var A4 = this.game.add.tween(this.clouds[1]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, false, 3000);
                var A5 = this.game.add.tween(this.clouds[2]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false);
                var A6 = this.game.add.tween(this.clouds[2]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, false, 3000);
                var A7 = this.game.add.tween(this.clouds[3]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false);
                var A8 = this.game.add.tween(this.clouds[3]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, false, 3000);
                var A9 = this.game.add.tween(this.pers[0]).to({ x: Client.Globals.SP.L.x }, 1200, Phaser.Easing.Linear.None, false);
                var A10 = this.game.add.tween(this.clouds[4]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false);
                A0.chain(A1);
                A1.chain(A2);
                A2.chain(A3);
                A3.chain(A4);
                A4.chain(A5);
                A5.chain(A6);
                A6.chain(A7);
                A7.chain(A8);
                A8.chain(A9);
                A9.chain(A10);
                A0.start();
                A10.onComplete.add(function () {
                    this.nextBtn.visible = true;
                }, this);
            };
            CafeSceen.prototype.lastAnim = function () {
                this.nextBtn.visible = false;
                this.game.add.tween(this.clouds[4]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, true);
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    this.game.add.tween(Client.Globals.GIRL[i]).to({ x: this.girlPos[i][0] + 960 }, 1200, Phaser.Easing.Linear.None, true);
                }
                this.game.add.tween(this).to({}, 1500, Phaser.Easing.Linear.None, true, 100).onComplete.addOnce(function () {
                    Client.Globals.NextScreenID = 2;
                    Client.Globals.DRESS_ID = 1;
                    Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'onClick', name: 'next' });
                }, this);
            };
            CafeSceen.prototype.onNext = function (context) {
                context.lastAnim();
            };
            CafeSceen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0] + 960;
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                    Client.Globals.GIRL[i].scale.set(this.girlScaleX[i], this.girlScaleY[i]);
                }
                this.swapChildren(Client.Globals.GIRL[1], Client.Globals.GIRL[2]);
            };
            return CafeSceen;
        }(Client.AbstractScreen));
        Client.CafeSceen = CafeSceen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ClubScreen = (function (_super) {
            __extends(ClubScreen, _super);
            function ClubScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.selectBtn = [];
                this.lock = false;
                this.path = 'club';
            }
            ClubScreen.prototype.init = function () {
                this.createDoll();
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'start' });
            };
            ClubScreen.prototype.createGraphics = function () {
                this.add(new Phaser.Image(this.game, 0, 0, 'BackClub'));
                for (var i = 0; i < 3; i++) {
                    this.selectBtn.push(new Client.GlowObject(this.game, 960 / 2, 720 / 2, 'GameObjects', 'club_btn_' + i + '.png', this.onSelect, this, 'B' + i));
                    this.selectBtn[i].scaleOver = 1.05;
                    this.add(this.selectBtn[i]);
                }
                this.label = new Phaser.Image(this.game, 0, 0, 'GameObjects', this.path + "_label.png");
                this.add(this.label);
            };
            ClubScreen.prototype.startAnim = function () {
            };
            ClubScreen.prototype.onSelect = function (context) {
                if (!context.lock) {
                    context.nextScreen(parseInt(this.name.charAt(1)));
                    context.lock = true;
                }
            };
            ClubScreen.prototype.nextScreen = function (ID) {
                Client.Globals.PATH = ID;
            };
            ClubScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = 1200;
                    Client.Globals.GIRL[i].y = 0;
                }
            };
            return ClubScreen;
        }(Client.AbstractScreen));
        Client.ClubScreen = ClubScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var DecorScreen = (function (_super) {
            __extends(DecorScreen, _super);
            function DecorScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.pers = [];
                this.maxPers = 1;
                this.PS = ['R'];
                this.clouds = [];
                this.maxClouds = 2;
                this.path = 'decor';
                this.items = [];
                this.btns = [];
                this.maxBtn = 3;
                this.maxElems = 6;
                this.phase = -1;
                this.done = [false, false, false];
                this.lock = false;
            }
            DecorScreen.prototype.init = function () {
                this.createGraphics();
                this.startAnim();
                this.setView('init');
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            DecorScreen.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, 'BackDecor');
                this.add(this.background);
                for (var i = 0; i < this.maxBtn; i++) {
                    this.items.push([]);
                    for (var j = 0; j < this.maxElems; j++) {
                        this.items[i].push(new Phaser.Image(this.game, 0, 0, 'Decor', this.path + "_elem_" + i + "_" + j + ".png"));
                        this.add(this.items[i][j]);
                        this.items[i][j].visible = false;
                    }
                }
                for (var i = 0; i < this.maxBtn; i++) {
                    this.btns.push(new Client.GlowObject(this.game, 480, 360, 'Decor', this.path + "_btn_" + i + ".png", this.onClick, this, "B" + i));
                    this.add(this.btns[i]);
                    this.btns[i].alpha = 0;
                    this.btns[i].visible = false;
                }
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.more = new Client.More(this.game, this.path, 'Decor');
                    this.add(this.more);
                    this.more.alpha = 0;
                    this.more.visible = false;
                }
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'Decor', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'Decor', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                this.doneBtn = new Client.GlowObject(this.game, 70, 655, 'main', 'nextBtn_normal.png', this.onNext, this);
                this.add(this.doneBtn);
                this.doneBtn.visible = false;
            };
            DecorScreen.prototype.startAnim = function () {
                var _this = this;
                for (var i = 0; i < this.maxPers; i++) {
                    this.game.add.tween(this.pers[i]).to({ x: 0, y: 0 }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                }
                this.game.add.tween(this.clouds[0]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100 + 1200).onComplete.addOnce(function () {
                    _this.doneBtn.visible = true;
                }, this);
            };
            DecorScreen.prototype.onNext = function (context) {
                if (context.phase == -1) {
                    context.hideAnim();
                    context.phase++;
                }
                else if (context.phase == 0) {
                    context.finalAnim();
                }
            };
            DecorScreen.prototype.hideAnim = function () {
                this.doneBtn.visible = false;
                this.game.add.tween(this.clouds[0]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                this.game.add.tween(this.pers[0]).to({ x: 1200 }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100 + 450);
                for (var i = 0; i < this.maxBtn; i++) {
                    this.btns[i].visible = true;
                    this.game.add.tween(this.btns[i]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100 + 450 + 1000);
                }
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.more.visible = true;
                    this.game.add.tween(this.more).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100 + 450 + 1000);
                }
            };
            DecorScreen.prototype.finalAnim = function () {
                var _this = this;
                this.doneBtn.visible = false;
                this.game.add.tween(this.clouds[1]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100 + 1200);
                this.game.add.tween(this.pers[0]).to({ x: 0 }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100).onComplete.addOnce(function () {
                    _this.showNextBtn();
                }, this);
                for (var i = 0; i < this.maxBtn; i++) {
                    this.game.add.tween(this.btns[i]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                }
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.game.add.tween(this.more).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100).onComplete.addOnce(function () {
                        _this.more.visible = false;
                    }, this);
                }
                this.game.add.tween(this).to({}, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100).onComplete.addOnce(function () {
                    for (var i = 0; i < _this.maxBtn; i++) {
                        _this.btns[i].visible = false;
                    }
                }, this);
                if (Client.Config.VERSION_ID == 'FULL') {
                    this.game.add.tween(this.more).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100 + 450 + 1000);
                }
            };
            DecorScreen.prototype.onClick = function (context) {
                var ID = parseInt(this.name.charAt(1));
                context.setView(ID);
            };
            DecorScreen.prototype.setView = function (ID) {
                if (ID != 'init') {
                    if (!this.lock) {
                        this.done[ID] = true;
                        if (Client.Utils.checkArr(this.done)) {
                            this.doneBtn.visible = true;
                            this.lock = true;
                        }
                    }
                    Client.Globals.MAKET[ID]++;
                    if (Client.Globals.MAKET[ID] == this.maxElems) {
                        Client.Globals.MAKET[ID] = -1;
                    }
                }
                for (var i = 0; i < this.maxBtn; i++) {
                    for (var j = 0; j < this.maxElems; j++) {
                        this.items[i][j].visible = false;
                        if (Client.Globals.MAKET[i] != -1) {
                            this.items[i][Client.Globals.MAKET[i]].visible = true;
                        }
                    }
                }
            };
            DecorScreen.prototype.showNextBtn = function () {
                Client.Globals.NextScreenID = 3;
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
            };
            return DecorScreen;
        }(Client.AbstractScreen));
        Client.DecorScreen = DecorScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var DressScreen = (function (_super) {
            __extends(DressScreen, _super);
            function DressScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'dress';
                this.girlPos = [[357, 33], [256, 25], [416, 41]];
                this.girlScaleX = [1, 1, 1];
                this.girlScaleY = [1, 1, 1];
                this.iGirl = [[0], [1, 2]];
                this.pers = [];
                this.maxPers = 1;
                this.PS = ['R'];
                this.clouds = [];
                this.maxClouds = 1;
                this.elems = [];
                this.EP = ['L', 'R'];
                this.maxElems = 2;
                this.NBP = [660, 470];
                this.LP = [482, 47];
            }
            DressScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy(true, false);
                Client.Event.onDollEvent.remove(this.setView, this);
                Client.Event.onItemsEvent.remove(this.updateLogic, this);
            };
            DressScreen.prototype.init = function () {
                Client.Globals.DRESS_ID++;
                Client.Globals.DONE[Client.Globals.DRESS_ID] = true;
                Client.Globals.GIRL_ID = this.iGirl[Client.Globals.DRESS_ID][0];
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
                Client.Event.onDollEvent.add(this.setView, this);
            };
            DressScreen.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, "BackDress");
                this.add(this.background);
                Client.Globals.CASE = new Client.DressCase(this.game);
                this.add(Client.Globals.CASE);
                Client.Globals.CASE.setView(Client.Globals.GIRL_ID, 0);
                Client.Globals.CASE.x = 0;
                Client.Globals.CASE.visible = true;
                Client.Globals.CASE.isActive = true;
                Client.Event.onItemsEvent.add(this.updateLogic, this);
                this.label = new Phaser.Image(this.game, this.LP[0], this.LP[1], 'GameObjects', this.path + "_label.png");
                this.add(this.label);
                this.label.scale.set(0.8);
                this.label.anchor.set(0.5);
                Client.Globals.DRESS_ID == 0 ? this.label.visible = true : this.label.visible = false;
                this.game.add.tween(this.label.scale).to({ x: 1, y: 1 }, 700, Phaser.Easing.Linear.None, true, Client.Globals.DELAY, Number.MAX_VALUE, true);
                this.createDoll();
                for (var i = 0; i < this.maxElems; i++) {
                    this.elems.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxElems > 1 ? this.path + "_fake_" + i + ".png" : this.path + "_fake.png"));
                    this.elems[i].position.set(Client.Globals.SP[this.EP[i]]['x'], Client.Globals.SP[this.EP[i]]['y']);
                    this.add(this.elems[i]);
                }
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                this.nextBtn = new Client.GlowObject(this.game, this.NBP[0], this.NBP[1], 'GameObjects', this.path + "_btn.png", this.onNext, this);
                this.add(this.nextBtn);
                this.nextBtn.visible = false;
                this.nextBtn.alpha = 0;
            };
            DressScreen.prototype.startAnim = function () {
                var _this = this;
                if (Client.Globals.DRESS_ID == 1) {
                    Client.Globals.GIRL[1].x = -960;
                    Client.Globals.GIRL[2].x = 960;
                    Client.Globals.CASE.visible = false;
                    var A0 = this.game.add.tween(this.pers[0]).to({ x: 0, y: 0 }, 1000, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                    var A1 = this.game.add.tween(this.clouds[0]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, false, 100);
                    A1.onComplete.addOnce(function () {
                        _this.nextBtn.visible = true;
                        _this.game.add.tween(_this.nextBtn.scale).to({ x: 1.05, y: 1.05 }, 500, Phaser.Easing.Linear.None, true, 0, Number.MAX_VALUE, true);
                        _this.game.add.tween(_this.nextBtn).to({ alpha: 1 }, 500, Phaser.Easing.Linear.None, true);
                    }, this);
                    A0.chain(A1);
                }
            };
            DressScreen.prototype.onNext = function (context) {
                context.nextAnim();
            };
            DressScreen.prototype.nextAnim = function () {
                var _this = this;
                this.game.add.tween(this.nextBtn).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, true).onComplete.addOnce(function () {
                    _this.nextBtn.visible = false;
                }, this);
                this.game.add.tween(this.clouds[0]).to({ alpha: 0 }, 450, Phaser.Easing.Linear.None, true);
                this.game.add.tween(this.pers[0]).to({ x: -960 }, 1200, Phaser.Easing.Linear.None, true, 450).onComplete.addOnce(function () {
                    _this.game.add.tween(Client.Globals.GIRL[1]).to({ x: _this.girlPos[1][0], y: _this.girlPos[1][1] }, 1000, Phaser.Easing.Linear.None, true, Client.Globals.DELAY);
                    _this.game.add.tween(Client.Globals.GIRL[2]).to({ x: _this.girlPos[2][0], y: _this.girlPos[2][1] }, 1000, Phaser.Easing.Linear.None, true, Client.Globals.DELAY);
                    _this.game.add.tween(_this.elems[0]).to({ x: 0, y: 0 }, 1000, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 1000);
                    _this.game.add.tween(_this.elems[1]).to({ x: 0, y: 0 }, 1000, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 1000);
                    _this.game.add.tween(_this).to({}, 1000, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 1100).onComplete.addOnce(function () {
                        _this.elems[0].visible = false;
                        _this.elems[1].visible = false;
                        Client.Globals.CASE.visible = true;
                        for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                            Client.Globals.GIRL[i].setView();
                        }
                    }, _this);
                }, this);
            };
            DressScreen.prototype.setView = function (param) {
                var OLD_ID = Client.Globals.GIRL_ID;
                Client.Globals.GIRL_ID = param.id;
                var oldPage = Client.Globals.CASE.page;
                Client.Globals.CASE.setView(Client.Globals.GIRL_ID, oldPage);
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    if (i == Client.Globals.GIRL_ID) {
                        Client.Globals.GIRL[i].glowAlways = true;
                    }
                    else {
                        Client.Globals.GIRL[i].glowAlways = false;
                    }
                    Client.Globals.GIRL[i].setView();
                }
            };
            DressScreen.prototype.updateLogic = function () {
                var score = [];
                for (var i = 0; i < this.iGirl.length; i++) {
                    score.push([]);
                    for (var j = 0; j < this.iGirl[i].length; j++) {
                        score[i].push(false);
                    }
                }
                for (var i = 0; i < this.iGirl[Client.Globals.DRESS_ID].length; i++) {
                    if (Client.Globals.DOLLS_VIEW[this.iGirl[Client.Globals.DRESS_ID][i]][1] != 0 && Client.Globals.DOLLS_VIEW[this.iGirl[Client.Globals.DRESS_ID][i]][4] != 0) {
                        score[Client.Globals.DRESS_ID][i] = true;
                    }
                    if (Client.Globals.DOLLS_VIEW[this.iGirl[Client.Globals.DRESS_ID][i]][2] != 0 && Client.Globals.DOLLS_VIEW[this.iGirl[Client.Globals.DRESS_ID][i]][3] != 0 && Client.Globals.DOLLS_VIEW[this.iGirl[Client.Globals.DRESS_ID][i]][4] != 0) {
                        score[Client.Globals.DRESS_ID][i] = true;
                    }
                }
                if (Client.Utils.checkArr(score[Client.Globals.DRESS_ID])) {
                    this.showNext();
                }
                else {
                    this.hideNext();
                }
            };
            DressScreen.prototype.showNext = function () {
                if (!Client.Utils.checkArr(Client.Globals.DONE)) {
                    Client.Globals.NextScreenID = 2;
                }
                else {
                    Client.Globals.NextScreenID = 3;
                }
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
            };
            DressScreen.prototype.hideNext = function () {
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            DressScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = true;
                    Client.Globals.GIRL[i].setGlow = true;
                    if (i == 1) {
                        Client.Globals.GIRL[i].glowAlways = true;
                    }
                    if (i == 0) {
                        Client.Globals.GIRL[i].setActive = false;
                        Client.Globals.GIRL[i].setGlow = false;
                    }
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = 0;
                    Client.Globals.GIRL[i].y = 0;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0];
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                    Client.Globals.GIRL[i].scale.set(this.girlScaleX[i], this.girlScaleY[i]);
                    if (!Client.Utils.inArray(i, this.iGirl[Client.Globals.DRESS_ID])) {
                        Client.Globals.GIRL[i].x = 1200;
                    }
                }
            };
            return DressScreen;
        }(Client.AbstractScreen));
        Client.DressScreen = DressScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var EndScreen = (function (_super) {
            __extends(EndScreen, _super);
            function EndScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'end';
                this.girlPos = [[346, 18], [493, 14], [133, 37]];
                this.girlScaleX = [1, 1, 1];
                this.girlScaleY = [1, 1, 1];
                this.promo = [];
                this.labels = [];
                this.bannerPs = [[248, 360], [711, 360]];
            }
            EndScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy();
            };
            EndScreen.prototype.init = function () {
                Client.Globals.PATH++;
                if (Client.Globals.PATH == 0) {
                    if (Client.Config.VERSION_ID == 'DUW' || Client.Config.VERSION_ID == 'GGG') {
                        Client.Globals.NextScreenID = 0;
                        Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'end' });
                    }
                    else {
                        Client.Globals.NextScreenID = 3;
                        Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
                    }
                }
                else {
                    Client.Globals.NextScreenID = 0;
                    Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'end' });
                }
                this.createGraphics();
                this.startAnim();
            };
            EndScreen.prototype.createGraphics = function () {
                this.add(new Phaser.Image(this.game, 0, 0, 'BackEnd'));
                this.createDoll();
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i].x = Client.Globals.GIRL[i].x - 1200;
                }
                if (Client.Config.VERSION_ID == 'DUW' || Client.Config.VERSION_ID == 'GGG') {
                }
                else {
                    for (var i = 0; i < Client.Config.CROSS.length; i++) {
                        this.promo.push(new Client.PromoBtn(this.game, 'GameObjects', "end_promo_" + i, i));
                        this.promo[i].x = this.bannerPs[i][0];
                        this.promo[i].y = this.bannerPs[i][1];
                        this.add(this.promo[i]);
                        this.promo[i].visible = false;
                        this.promo[i].alpha = 0;
                        this.promo[i].setGlow = false;
                        this.promo[i].setScaleOver = 1.05;
                        this.labels.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.path + "_label_" + i + ".png"));
                        this.add(this.labels[i]);
                        this.labels[i].alpha = 0;
                    }
                }
            };
            EndScreen.prototype.startAnim = function () {
                if (Client.Globals.PATH == 0) {
                    for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                        this.game.add.tween(Client.Globals.GIRL[i]).to({ x: this.girlPos[i][0], y: this.girlPos[i][1] }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                    }
                }
                else {
                    for (var i = 0; i < Client.Config.CROSS.length; i++) {
                        this.promo[i].visible = true;
                        this.game.add.tween(this.promo[i]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY);
                        this.game.add.tween(this.labels[i]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY);
                    }
                }
            };
            EndScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0];
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                    Client.Globals.GIRL[i].scale.set(this.girlScaleX[i], this.girlScaleY[i]);
                }
                this.swapChildren(Client.Globals.GIRL[0], Client.Globals.GIRL[1]);
                this.swapChildren(Client.Globals.GIRL[0], Client.Globals.GIRL[2]);
            };
            return EndScreen;
        }(Client.AbstractScreen));
        Client.EndScreen = EndScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var FakeEnd = (function (_super) {
            __extends(FakeEnd, _super);
            function FakeEnd(game) {
                _super.call(this, game);
                this.game = game;
                this.path = 'photo';
                this.girlPos = [[319, -16]];
                this.createGraphics();
                this.x = -89;
                this.y = 165;
            }
            FakeEnd.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, "BackPhoto_" + Client.Globals.PATH);
                this.add(this.background);
                this.createDoll();
            };
            FakeEnd.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0];
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                    if (Client.Globals.GIRL_ID != i) {
                        Client.Globals.GIRL[i].x = 1200;
                    }
                }
            };
            return FakeEnd;
        }(Phaser.Group));
        Client.FakeEnd = FakeEnd;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GameScreen = (function (_super) {
            __extends(GameScreen, _super);
            function GameScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'game';
                this.girlPos = [
                    [614, 8],
                    [920, 8],
                    [392, 8],
                    [-105, 47],
                    [1115, 55]
                ];
                this.GS = ['L', 'R', 'L', 'L', 'R'];
                this.girlScaleX = [-0.9, -0.9, 0.9, 0.95, -0.95];
                this.girlScaleY = [0.9, 0.9, 0.9, 0.95, 0.95];
                this.sets = [
                    [6, 9, 0, 0, 2, 5, 0, 0, 0],
                    [3, 7, 0, 0, 1, 6, 1, 0, 0],
                    [1, 5, 0, 0, 3, 3, 2, 0, 0],
                    [3, 2, 0, 0, 3, 6, 0, 0, 0],
                    [4, 8, 0, 0, 4, 0, 0, 0, 0]
                ];
                this.girls = [];
                this.maxGirls = 5;
                this.pers = [];
                this.maxPers = 1;
                this.PS = ['L'];
                this.clouds = [];
                this.maxClouds = 2;
                this.rays = [];
                this.maxRays = 5;
            }
            GameScreen.prototype.init = function () {
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            GameScreen.prototype.createGraphics = function () {
                this.createDoll();
                this.background = new Phaser.Image(this.game, 0, 0, "BackGame");
                this.add(this.background);
                for (var i = 0; i < this.maxRays; i++) {
                    this.rays.push(new Phaser.Image(this.game, 0, 0, 'Game', this.path + "_ray_" + i + ".png"));
                    this.add(this.rays[i]);
                    this.rays[i].alpha = 0;
                }
                for (var i = 0; i < this.maxGirls; i++) {
                    if (i != Client.Globals.PATH) {
                        for (var j = 0; j < Client.Globals.DOLLS_VIEW[i].length; j++) {
                            Client.Globals.DOLLS_VIEW[i][j] = this.sets[i][j];
                        }
                    }
                    this.girls.push(new Client.Doll(this.game, i));
                    this.girls[i].x = this.girlPos[i][0];
                    this.girls[i].y = this.girlPos[i][1];
                    this.girls[i].scale.set(this.girlScaleX[i], this.girlScaleY[i]);
                    this.girls[i].setActive = false;
                    this.girls[i].setView();
                    this.add(this.girls[i]);
                    this.GS[i] == 'L' ? this.girls[i].x = -2400 : this.girls[i].x = 2400;
                }
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'Game', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'Game', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                this.nextBtn = new Client.GlowObject(this.game, 70, 655, 'main', 'nextBtn_normal.png', this.onClick, this);
                this.add(this.nextBtn);
                this.nextBtn.visible = false;
            };
            GameScreen.prototype.startAnim = function () {
                var _this = this;
                for (var i = 0; i < this.maxGirls; i++) {
                    this.game.add.tween(this.girls[i]).to({ x: this.girlPos[i][0], y: this.girlPos[i][1] }, 1400, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 500 * i);
                }
                this.game.add.tween(this).to({}, 5000, Phaser.Easing.Linear.None, true).onComplete.addOnce(function () {
                    _this.game.add.tween(_this.clouds[0]).to({ alpha: 1 }, 500, Phaser.Easing.Linear.None, true).onComplete.addOnce(function () {
                        _this.nextBtn.visible = true;
                    }, _this);
                }, this);
            };
            GameScreen.prototype.onClick = function (context) {
                context.startGame();
            };
            GameScreen.prototype.startGame = function () {
                this.nextBtn.visible = false;
                this.game.add.tween(this.clouds[0]).to({ alpha: 0 }, 500, Phaser.Easing.Linear.None, true);
                Client.Globals.WINNER = this.setWinner();
                this.raysAnim(Client.Globals.WINNER);
            };
            GameScreen.prototype.setWinner = function () {
                var WIN = -1;
                var RND = Math.random();
                RND > 0.3 ? WIN = Client.Globals.PATH : WIN = this.getMeNumber();
                return WIN;
            };
            GameScreen.prototype.getMeNumber = function () {
                var num = Math.round(Math.random() * 4);
                num == Client.Globals.PATH ? num = this.getMeNumber() : num;
                return num;
            };
            GameScreen.prototype.raysAnim = function (ID) {
                var _this = this;
                var animArr = [];
                for (var j = 0; j < 3; j++) {
                    for (var i = 0; i < this.maxRays; i++) {
                        animArr.push(this.game.add.tween(this.rays[i]).to({ alpha: 1 }, 200, Phaser.Easing.Linear.None, false));
                        animArr.push(this.game.add.tween(this.rays[i]).to({ alpha: 0 }, 200, Phaser.Easing.Linear.None, false));
                    }
                }
                for (var i = 0; i < this.maxRays; i++) {
                    if (i < ID) {
                        animArr.push(this.game.add.tween(this.rays[i]).to({ alpha: 1 }, 200, Phaser.Easing.Linear.None, false));
                        animArr.push(this.game.add.tween(this.rays[i]).to({ alpha: 0 }, 200, Phaser.Easing.Linear.None, false));
                    }
                    if (i == ID) {
                        animArr.push(this.game.add.tween(this.rays[i]).to({ alpha: 1 }, 200, Phaser.Easing.Linear.None, false));
                    }
                }
                for (var i = 0; i < animArr.length - 1; i++) {
                    animArr[i].chain(animArr[i + 1]);
                }
                animArr[0].start();
                animArr[animArr.length - 1].onComplete.addOnce(function () {
                    for (var i = 0; i < _this.maxPers; i++) {
                        _this.game.add.tween(_this.pers[i]).to({ x: 0, y: 0 }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                    }
                    _this.game.add.tween(_this.clouds[1]).to({ alpha: 1 }, 450, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 1200 + 100).onComplete.addOnce(function () {
                        Client.Globals.NextScreenID = 5;
                        Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
                    }, _this);
                }, this);
            };
            GameScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = 0;
                    Client.Globals.GIRL[i].y = 0;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0] + 2400;
                    Client.Globals.GIRL[i].y = this.girlPos[i][1] + 2400;
                    Client.Globals.GIRL[i].scale.set(this.girlScaleX[i], this.girlScaleY[i]);
                }
            };
            return GameScreen;
        }(Client.AbstractScreen));
        Client.GameScreen = GameScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var MakeScreen = (function (_super) {
            __extends(MakeScreen, _super);
            function MakeScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.background = [];
                this.path = 'make';
                this.girlPos = [[0, 0], [1200, 0], [1200, 0], [1200, 0]];
                this.pers = [];
                this.maxPers = 3;
                this.PS = ['R', 'L', 'L'];
                this.clouds = [];
                this.maxClouds = 3;
                this.lock = true;
                this.cnt = 0;
            }
            MakeScreen.prototype.init = function () {
                Client.Globals.GIRL_ID = 0;
                this.lock = false;
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            MakeScreen.prototype.createGraphics = function () {
                this.background.push(new Phaser.Image(this.game, 0, 0, 'BackMake'));
                for (var i = 0; i < this.background.length; i++) {
                    this.add(this.background[i]);
                }
                this.createDoll();
                Client.Globals.CASE = new Client.DressCase(this.game);
                this.add(Client.Globals.CASE);
                Client.Globals.CASE.setView(Client.Globals.GIRL_ID, 0);
                Client.Globals.CASE.x = 0;
                Client.Globals.CASE.visible = true;
                Client.Globals.CASE.isActive = true;
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.pers[i].inputEnabled = true;
                    this.pers[i].input.pixelPerfectClick = this.pers[i].input.pixelPerfectOver = true;
                    this.pers[i].input.pixelPerfectAlpha = 10;
                    this.pers[i].name = "p" + i;
                    this.pers[i].events.onInputDown.add(this.onClickPers, this);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
            };
            MakeScreen.prototype.startAnim = function () {
                this.game.add.tween(this.pers[this.cnt]).to({ x: 0, y: 0 }, 700, Phaser.Easing.Linear.None, true, 200);
                this.game.add.tween(this.clouds[this.cnt]).to({ alpha: 1 }, 700, Phaser.Easing.Linear.None, true, 900);
                var LA = this.game.add.tween(this).to({ x: 0 }, 700, Phaser.Easing.Linear.None, true, 900 + 700 + 500 + 5000);
                LA.onComplete.add(this.switchGirl, this);
            };
            MakeScreen.prototype.switchGirl = function () {
                this.game.add.tween(this.pers[this.cnt]).to({ x: Client.Globals.SP[this.PS[this.cnt]]['x'], y: Client.Globals.SP[this.PS[this.cnt]]['y'] }, 700, Phaser.Easing.Linear.None, true, 300);
                this.game.add.tween(this.clouds[this.cnt]).to({ alpha: 0 }, 300, Phaser.Easing.Linear.None, true);
                this.cnt++;
                if (this.cnt == this.maxPers) {
                    this.cnt = 0;
                }
                var LA = this.game.add.tween(this).to({ x: 0 }, 700, Phaser.Easing.Linear.None, true, 12000);
                LA.onComplete.add(this.startAnim, this);
            };
            MakeScreen.prototype.onClickPers = function (target) {
                var ID = parseInt(target.name.charAt(1));
                this.game.tweens.removeFrom(this);
                this.game.tweens.removeFrom(target);
                this.game.tweens.removeFrom(this.clouds[ID]);
                this.game.add.tween(this.pers[ID]).to({ x: Client.Globals.SP[this.PS[ID]]['x'], y: Client.Globals.SP[this.PS[ID]]['y'] }, 700, Phaser.Easing.Linear.None, true, 300);
                this.game.add.tween(this.clouds[ID]).to({ alpha: 0 }, 300, Phaser.Easing.Linear.None, true);
            };
            MakeScreen.prototype.update = function () {
                _super.prototype.update.call(this);
                if (!this.lock) {
                    for (var i = 0; i < Client.Globals.DOLLS_VIEW[Client.Globals.GIRL_ID].length; i++) {
                        if (Client.Globals.DOLLS_VIEW[Client.Globals.GIRL_ID][i] != 0) {
                            this.lock = true;
                            Client.Globals.NextScreenID = 3;
                            Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
                        }
                    }
                }
            };
            MakeScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0];
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                    if (Client.Globals.GIRL_ID != i) {
                        Client.Globals.GIRL[i].x = 1200;
                    }
                }
            };
            return MakeScreen;
        }(Client.AbstractScreen));
        Client.MakeScreen = MakeScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PhotoScreen = (function (_super) {
            __extends(PhotoScreen, _super);
            function PhotoScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'photo';
                this.backgrounds = [];
                this.girlPos = [[257, 62], [445, 89]];
                this.girlScaleX = [.9, .9];
                this.girlScaleY = [.9, .9];
                this.icons = [];
                this.iconID = [1, 3, 5];
                this.cnt = 0;
            }
            PhotoScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy();
            };
            PhotoScreen.prototype.init = function () {
                this.createGraphics();
                Client.Globals.NextScreenID = 4;
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            PhotoScreen.prototype.createGraphics = function () {
                for (var i = 0; i < 3; i++) {
                    this.backgrounds.push(new Phaser.Image(this.game, 0, 0, "BackPhoto_" + i));
                    this.add(this.backgrounds[i]);
                    if (i > 0) {
                        this.backgrounds[i].alpha = 0;
                    }
                }
                this.createDoll();
                for (var i = 0; i < 5; i++) {
                    this.add(new Phaser.Image(this.game, 0, 0, 'Photo', this.path + "_elem_" + i + ".png"));
                }
                for (var i = 0; i < 3; i++) {
                    this.icons.push(new Phaser.Image(this.game, 0, 0, "Photo", this.path + "_icon_" + i + "_0.png"));
                    this.icons.push(new Phaser.Image(this.game, 0, 0, "Photo", this.path + "_icon_" + i + "_1.png"));
                }
                for (var i = 0; i < this.icons.length; i++) {
                    this.add(this.icons[i]);
                }
                this.photoBtn = new Client.GlowObject(this.game, 960 / 2, 720 / 2, 'Photo', 'photo_btn.png', this.onPhoto, this);
                this.add(this.photoBtn);
                this.flash = new Phaser.Image(this.game, 0, 0, "Back");
                this.flash.alpha = 0;
                this.add(this.flash);
            };
            PhotoScreen.prototype.onPhoto = function (context) {
                context.startAnim();
            };
            PhotoScreen.prototype.startAnim = function () {
                this.flash.alpha = 1;
                this.game.add.tween(this.flash).to({ alpha: 0 }, 300, Phaser.Easing.Linear.None, true);
                this.backgrounds[this.cnt].alpha = 0;
                this.icons[this.iconID[this.cnt]].visible = false;
                this.cnt++;
                if (this.cnt < 3) {
                    this.backgrounds[this.cnt].alpha = 1;
                }
                else {
                    this.backgrounds[2].alpha = 1;
                    this.photoBtn.visible = false;
                    if (Client.Config.VERSION_ID == 'GGG' || Client.Config.VERSION_ID == 'DUW') {
                        for (var i = 0; i < this.icons.length; i++) {
                            this.game.add.tween(this.icons[i]).to({ alpha: 0 }, 300, Phaser.Easing.Linear.None, true);
                        }
                        Client.Globals.NextScreenID = 0;
                        Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'end' });
                    }
                    else {
                        Client.Globals.NextScreenID = 4;
                        Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
                    }
                }
            };
            PhotoScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0];
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                }
            };
            return PhotoScreen;
        }(Client.AbstractScreen));
        Client.PhotoScreen = PhotoScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PreendScreen = (function (_super) {
            __extends(PreendScreen, _super);
            function PreendScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'preend';
                this.girlPos = [[329, -14], [-43, -55]];
                this.girlScale = [0.82, 0.82];
                this.pers = [];
                this.maxPers = 0;
                this.PS = ['L'];
                this.clouds = [];
                this.maxClouds = 0;
            }
            PreendScreen.prototype.init = function () {
                this.createGraphics();
                this.startAnim();
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            PreendScreen.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, "BackSelect");
                this.add(this.background);
                this.add(new Client.Lights(this.game, 2, 'back_tinsel', 'GameObjects'));
                this.createDoll();
                this.nextBtn = new Client.GlowObject(this.game, 960 / 2, 720 / 2, 'GameObjects', this.path + "_btn.png", this.onNext, this);
                this.add(this.nextBtn);
            };
            PreendScreen.prototype.startAnim = function () {
            };
            PreendScreen.prototype.onNext = function (context) {
                Client.Globals.NextScreenID = 1;
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'onClick', name: 'next' });
            };
            PreendScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = this.girlPos[i][0];
                    Client.Globals.GIRL[i].y = this.girlPos[i][1];
                    Client.Globals.GIRL[i].scale.set(this.girlScale[i]);
                }
            };
            return PreendScreen;
        }(Client.AbstractScreen));
        Client.PreendScreen = PreendScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var PromoScreen = (function (_super) {
            __extends(PromoScreen, _super);
            function PromoScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.promo = [];
                this.path = 'promo';
                this.pers = [];
                this.persMax = 1;
                this.PS = ['R'];
                this.clouds = [];
                this.cloudsMax = 1;
                this.play = [];
            }
            PromoScreen.prototype.init = function () {
                this.createDoll();
                this.createGraphics();
                this.startAnim();
                Client.Globals.NextScreenID = 0;
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'end' });
            };
            PromoScreen.prototype.createGraphics = function () {
                this.add(new Client.FakeEnd(this.game));
                this.background = new Phaser.Image(this.game, 0, 0, 'GameObjects', 'promo_back.png');
                this.add(this.background);
                for (var i = 0; i < Client.Config.CROSS.length; i++) {
                    this.promo.push(new Client.GlowObject(this.game, 960 / 2, 720 / 2, 'GameObjects', this.path + "_" + i + ".png", this.onClick, this, "P" + i));
                    this.add(this.promo[i]);
                }
                if (Client.Config.VERSION_ID == 'FULL') {
                    var MP = new Client.GlowObject(this.game, 880, 170, 'GameObjects', this.path + "_more.png", function () { Client.Utils.moreUrl('ingame_more_games'); }, this);
                    this.add(MP);
                    this.game.add.tween(MP.scale).to({ x: 1.05, y: 1.05 }, 450, Phaser.Easing.Linear.None, true, 750, Number.MAX_VALUE, true);
                }
                for (var i = 0; i < this.persMax; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.persMax > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.cloudsMax; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.cloudsMax > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                var PP = [[387, 588], [651, 588]];
                for (var i = 0; i < 2; i++) {
                    this.play.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.path + "_play_" + i + ".png"));
                    this.play[i].position.set(PP[i][0], PP[i][1]);
                    this.play[i].anchor.set(0.5);
                    this.add(this.play[i]);
                    this.game.add.tween(this.play[i].scale).to({ x: 1.05, y: 1.05 }, 450, Phaser.Easing.Linear.None, true, 750, 9999, true);
                }
            };
            PromoScreen.prototype.startAnim = function () {
                this.game.add.tween(this.pers[0]).to({ x: 0, y: 0 }, 800, Phaser.Easing.Linear.None, true, 500);
                this.game.add.tween(this.clouds[0]).to({ alpha: 1 }, 500, Phaser.Easing.Linear.None, true, 1300);
            };
            PromoScreen.prototype.onClick = function (context) {
                var url = document.referrer;
                var l = document.createElement('a');
                l.href = url;
                var loc = l;
                var promoURL = Client.Config.CROSS[parseInt(this.name.charAt(1))] + "?utm_source=" + loc.hostname + "&utm_campaign=" + Client.Config.MORE_CONFIG.gameID + "&utm_medium=referral&utm_content=crosspromo";
                window.open(promoURL);
            };
            PromoScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].x = 1200;
                }
            };
            return PromoScreen;
        }(Client.AbstractScreen));
        Client.PromoScreen = PromoScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var SaverScreen = (function (_super) {
            __extends(SaverScreen, _super);
            function SaverScreen(game, phase) {
                var _this = this;
                _super.call(this, game);
                this.game = game;
                this.startPos = [];
                this.animPos = [];
                if (!Client.Config.SAVER.type) {
                    if (phase == 'open') {
                        Client.Event.onScreenEvent.dispatch({ type: 'switchScreen' });
                    }
                    if (phase == 'close') {
                        this.destroy();
                    }
                }
                if (Client.Config.SAVER.logo) {
                    this.GL = new Client.GameLogo(this.game, 'Saver', Client.Config.SAVER.typeL);
                }
                if (Client.Config.SAVER.type == 'V') {
                    if (phase == 'open') {
                        this.FL = new Phaser.Image(this.game, 0, 0, 'FL');
                        this.FL.position.set(0, 0);
                        this.startPos.push(this.FL.x);
                        this.add(this.FL);
                        this.FR = new Phaser.Image(this.game, 0, 0, 'FR');
                        this.FR.position.set(0, 0);
                        this.startPos.push(this.FR.x);
                        this.add(this.FR);
                        this.add(this.GL);
                        this.FL.x = -this.FL.width;
                        this.FR.x = 960;
                        this.animPos.push(this.FL.x);
                        this.animPos.push(this.FR.x);
                        this.GL.visible = true;
                        if (Client.Config.SAVER.logo == 'S') {
                            this.GL.scale.set(0);
                        }
                        if (Client.Config.SAVER.logo == 'A') {
                            this.GL.alpha = 0;
                        }
                        var FLT = this.game.add.tween(this.FL).to({ x: this.startPos[0] }, 600, Phaser.Easing.Quadratic.Out, true);
                        var FRT = this.game.add.tween(this.FR).to({ x: this.startPos[1] }, 600, Phaser.Easing.Quadratic.Out, true);
                        var GLT = void 0;
                        if (Client.Config.SAVER.logo == 'S') {
                            GLT = this.game.add.tween(this.GL.scale).to({ x: 1, y: 1 }, 750, Phaser.Easing.Quadratic.Out, true);
                        }
                        if (Client.Config.SAVER.logo == 'A') {
                            GLT = this.game.add.tween(this.GL).to({ alpha: 1 }, 750, Phaser.Easing.Quadratic.Out, true);
                        }
                        GLT.onComplete.add(function () {
                            Client.Event.onScreenEvent.dispatch({ type: 'switchScreen' });
                        }, this);
                    }
                    if (phase == 'close') {
                        this.FL = new Phaser.Image(this.game, 0, 0, 'FL');
                        this.FL.position.set(0, 0);
                        this.startPos.push(this.FL.x);
                        this.add(this.FL);
                        this.FR = new Phaser.Image(this.game, 0, 0, 'FR');
                        this.FR.position.set(0, 0);
                        this.startPos.push(this.FR.x);
                        this.add(this.FR);
                        this.add(this.GL);
                        var FLTE = this.game.add.tween(this.FL).to({ x: -960 }, 600, Phaser.Easing.Quadratic.Out, true, 500);
                        var FRTE = this.game.add.tween(this.FR).to({ x: 960 }, 600, Phaser.Easing.Quadratic.Out, true, 500);
                        var GLTE = void 0;
                        if (Client.Config.SAVER.logo == 'S') {
                            GLTE = this.game.add.tween(this.GL.scale).to({ x: 0, y: 0 }, 750, Phaser.Easing.Quadratic.Out, true, 500);
                        }
                        if (Client.Config.SAVER.logo == 'A') {
                            GLTE = this.game.add.tween(this.GL).to({ alpha: 0 }, 750, Phaser.Easing.Quadratic.Out, true, 500);
                        }
                        GLTE.onComplete.add(function () {
                            this.GL.visible = false;
                            this.destroy();
                        }, this);
                    }
                }
                if (Client.Config.SAVER.type == 'VN') {
                    if (phase == 'open') {
                        this.FL = new Phaser.Image(this.game, 0, 0, 'FL');
                        this.FL.position.set(0, 0);
                        this.startPos.push(this.FL.x);
                        this.add(this.FL);
                        this.FR = new Phaser.Image(this.game, 0, 0, 'FR');
                        this.FR.position.set(0, 0);
                        this.startPos.push(this.FR.x);
                        this.add(this.FR);
                        this.FL.x = -this.FL.width;
                        this.FR.x = 960;
                        this.animPos.push(this.FL.x);
                        this.animPos.push(this.FR.x);
                        var FLT = this.game.add.tween(this.FL).to({ x: this.startPos[0] }, 600, Phaser.Easing.Quadratic.Out, true);
                        var FRT = this.game.add.tween(this.FR).to({ x: this.startPos[1] }, 600, Phaser.Easing.Quadratic.Out, true);
                        FRT.onComplete.add(function () {
                            Client.Event.onScreenEvent.dispatch({ type: 'switchScreen' });
                        }, this);
                    }
                    if (phase == 'close') {
                        this.FL = new Phaser.Image(this.game, 0, 0, 'FL');
                        this.FL.position.set(0, 0);
                        this.startPos.push(this.FL.x);
                        this.add(this.FL);
                        this.FR = new Phaser.Image(this.game, 0, 0, 'FR');
                        this.FR.position.set(0, 0);
                        this.startPos.push(this.FR.x);
                        this.add(this.FR);
                        var FLTE = this.game.add.tween(this.FL).to({ x: -960 }, 600, Phaser.Easing.Quadratic.Out, true, 500);
                        var FRTE = this.game.add.tween(this.FR).to({ x: 960 }, 600, Phaser.Easing.Quadratic.Out, true, 500);
                        FRTE.onComplete.add(function () {
                            this.destroy();
                        }, this);
                    }
                    this.FL.inputEnabled = true;
                    this.FL.input.pixelPerfectClick = this.FL.input.pixelPerfectOver = true;
                    this.FL.input.pixelPerfectAlpha = 10;
                    this.FL.events.onInputDown.addOnce(function () {
                        _this.openMore();
                    }, this);
                    this.FR.inputEnabled = true;
                    this.FR.input.pixelPerfectClick = this.FR.input.pixelPerfectOver = true;
                    this.FR.input.pixelPerfectAlpha = 10;
                    this.FR.events.onInputDown.addOnce(function () {
                        _this.openMore();
                    }, this);
                }
            }
            SaverScreen.prototype.openMore = function (id) {
                if (id === void 0) { id = 'main_logo'; }
                Client.Utils.moreUrl(id);
            };
            return SaverScreen;
        }(Phaser.Group));
        Client.SaverScreen = SaverScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var SelectScreen = (function (_super) {
            __extends(SelectScreen, _super);
            function SelectScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'select';
                this.selectBtn = [];
                this.maxSelect = 2;
                this.pers = [];
                this.maxPers = 0;
                this.PS = ['L', 'R'];
                this.clouds = [];
                this.maxClouds = 0;
                this.lock = false;
            }
            SelectScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy();
            };
            SelectScreen.prototype.init = function () {
                if (Client.Globals.PATH == -1) {
                    Client.Event.onScreenEvent.dispatch({ command: 'reload' });
                }
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
                this.createGraphics();
                this.startAnim();
            };
            SelectScreen.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, "BackSelect");
                this.add(this.background);
                this.createDoll();
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                for (var i = 0; i < this.maxSelect; i++) {
                    if (!Client.Globals.DONE[i]) {
                        this.selectBtn.push(new Client.GlowObject(this.game, 480, 360, 'GameObjects', this.path + "_btn_" + i + ".png", this.onClick, this, "S" + i));
                        this.add(this.selectBtn[i]);
                        this.selectBtn[i].setScale = 1.01;
                        this.selectBtn[i].setGlow = false;
                    }
                    else {
                        this.selectBtn.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', "select_btn_" + i + ".png"));
                        this.selectBtn[i].filters = [new Client.GrayFilter(this.game)];
                    }
                    this.add(this.selectBtn[i]);
                }
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
            };
            SelectScreen.prototype.startAnim = function () {
            };
            SelectScreen.prototype.onClick = function (context) {
                if (!context.lock) {
                    var ID = parseInt(this.name.charAt(1));
                    Client.Globals.DONE[ID] = true;
                    Client.Globals.PATH = ID;
                    Client.Globals.NextScreenID = 2;
                    Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'onClick', name: 'next' });
                    context.lock = true;
                }
            };
            SelectScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = 1200;
                }
            };
            return SelectScreen;
        }(Client.AbstractScreen));
        Client.SelectScreen = SelectScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ShowScreen = (function (_super) {
            __extends(ShowScreen, _super);
            function ShowScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'show';
                this.GS = [[395, 203], [372, 193], [1200, 0], [1200, 0]];
                this.GC = [[350, 160], [315, 150], [1200, 0], [1200, 0]];
                this.GE = [[64, 140], [613, 129], [1200, 0], [1200, 0]];
                this.SS = [0.5, 0.5, 1, 1];
                this.SE = [0.75, 0.75, 1, 1];
            }
            ;
            ;
            ShowScreen.prototype.init = function () {
                this.createGraphics();
                this.startAnim();
                Client.Globals.NextScreenID = 1;
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'done' });
            };
            ShowScreen.prototype.createGraphics = function () {
                this.background = new Phaser.Image(this.game, 0, 0, "BackShow");
                this.add(this.background);
                this.add(new Client.FlashAnim(this.game, 'extra_flash', 2, 3));
                this.more = new Client.MoreSprite(this.game, this.path + "_more", 29, 12, 'Show');
                this.more.alpha = 0;
                this.more.visible = false;
                this.add(this.more);
                this.createDoll();
            };
            ShowScreen.prototype.startAnim = function () {
                var _this = this;
                var _loop_2 = function(i) {
                    Client.Globals.GIRL[i].alpha = 0;
                    this_2.game.add.tween(Client.Globals.GIRL[i]).to({ alpha: 1 }, 500, Phaser.Easing.Linear.None, true, 1700 * i);
                    this_2.game.add.tween(Client.Globals.GIRL[i]).to({ x: this_2.GC[i][0], y: this_2.GC[i][1] }, 1200, Phaser.Easing.Linear.None, true, 500 + 1200 * i);
                    this_2.game.add.tween(Client.Globals.GIRL[i].scale).to({ x: this_2.SE[i], y: this_2.SE[i] }, 1200, Phaser.Easing.Linear.None, true, 500 + 1200 * i).onComplete.addOnce(function () {
                        _this.game.add.tween(Client.Globals.GIRL[i]).to({ x: _this.GE[i][0], y: _this.GE[i][1] }, 1200, Phaser.Easing.Linear.None, true);
                    }, this_2);
                };
                var this_2 = this;
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    _loop_2(i);
                }
                this.game.add.tween(this).to({}, 1200, Phaser.Easing.Linear.None, true, 500 + 1200 * 2).onComplete.addOnce(function () {
                    Client.Globals.NextScreenID = 1;
                    Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'next' });
                    if (Client.Config.VERSION_ID == 'FULL') {
                        _this.showPromo();
                    }
                }, this);
            };
            ShowScreen.prototype.showPromo = function () {
                this.more.visible = true;
                this.game.add.tween(this.more).to({ alpha: 1 }, 500, Phaser.Easing.Linear.None, true);
            };
            ShowScreen.prototype.createDoll = function () {
                for (var i = 0; i < Client.Globals.DOLLS_VIEW.length; i++) {
                    Client.Globals.GIRL[i] = new Client.Doll(this.game, i);
                    this.add(Client.Globals.GIRL[i]);
                    Client.Globals.GIRL[i].setActive = false;
                    Client.Globals.GIRL[i].setView();
                    Client.Globals.GIRL[i].visible = true;
                    Client.Globals.GIRL[i].x = this.GS[i][0];
                    Client.Globals.GIRL[i].y = this.GS[i][1];
                    Client.Globals.GIRL[i].scale.set(this.SS[i], this.SS[i]);
                }
            };
            return ShowScreen;
        }(Client.AbstractScreen));
        Client.ShowScreen = ShowScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var StartScreen = (function (_super) {
            __extends(StartScreen, _super);
            function StartScreen(game, screenID) {
                _super.call(this, game, screenID);
                this.game = game;
                this.screenID = screenID;
                this.path = 'start';
                this.backgrounds = [];
                this.maxBG = 1;
                this.pers = [];
                this.maxPers = 2;
                this.PS = ['L', 'R'];
                this.clouds = [];
                this.maxClouds = 0;
                this.PL = 'Z';
                this.LS = 0;
                Client.Event.onScreenEvent.dispatch({ command: 'reload' });
            }
            StartScreen.prototype.destroyMe = function () {
                this.pendingDestroy = true;
                this.destroy();
            };
            StartScreen.prototype.init = function () {
                this.createGraphics();
                this.startAnim();
                this.testObj();
                Client.Globals.NextScreenID = 1;
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', action: 'setView', view: 'start' });
            };
            StartScreen.prototype.createGraphics = function () {
                for (var i = 0; i < this.maxBG; i++) {
                    this.backgrounds.push(new Phaser.Image(this.game, 0, 0, this.maxBG == 1 ? "BackStart" : "BackStart_" + i));
                    this.add(this.backgrounds[i]);
                }
                for (var i = 0; i < this.maxPers; i++) {
                    this.pers.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxPers > 1 ? this.path + "_pers_" + i + ".png" : this.path + "_pers.png"));
                    this.pers[i].position.set(Client.Globals.SP[this.PS[i]]['x'], Client.Globals.SP[this.PS[i]]['y']);
                    this.add(this.pers[i]);
                }
                for (var i = 0; i < this.maxClouds; i++) {
                    this.clouds.push(new Phaser.Image(this.game, 0, 0, 'GameObjects', this.maxClouds > 1 ? this.path + "_cloud_" + i + ".png" : this.path + "_cloud.png"));
                    this.clouds[i].alpha = 0;
                    this.add(this.clouds[i]);
                }
                this.logo = new Phaser.Image(this.game, Client.Globals.SP[this.PL].x, Client.Globals.SP[this.PL].y, 'GameObjects', this.path + "_logo.png");
                this.add(this.logo);
            };
            StartScreen.prototype.startAnim = function () {
                var _this = this;
                this.logo.scale.set(0);
                this.logo.anchor.set(0.5);
                this.logo.position.set(960 / 2, 720 / 2);
                this.game.add.tween(this.logo.scale).to({ x: 1, y: 1 }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100).onComplete.addOnce(function () {
                    _this.game.add.tween(_this.logo).to({ y: 720 / 2 + 5 }, 1500, Phaser.Easing.Linear.None, true, 0, Number.MAX_VALUE, true);
                }, this);
                for (var i = 0; i < this.maxPers; i++) {
                    this.game.add.tween(this.pers[i]).to({ x: 0, y: 0 }, 1200, Phaser.Easing.Linear.None, true, Client.Globals.DELAY + 100);
                }
            };
            StartScreen.prototype.testObj = function () {
            };
            return StartScreen;
        }(Client.AbstractScreen));
        Client.StartScreen = StartScreen;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Config = (function () {
            function Config() {
            }
            Config.REV = '1.0';
            Config.VERSION_ID = 'FULL';
            Config.EXTRA_MORE = { enabled: true, x: 960 - 217 / 2 + 15, y: 720 - 236 / 2 - 10, url: 'http://freegamescasual.com/search?q=jasmine' };
            Config.SAVER = { type: null, logo: null, anim: false, typeL: 'default' };
            Config.PREAD = false;
            Config.PUBLISHER = 'F';
            Config.AD_PARAM = { cnt: 0, max: 3, lock: false };
            Config.MORE_CONFIG = { domain: '', gameID: 'princess_anti_fashion_sporty_plus_classy' };
            Config.ADS_URL = 'https://googleads.g.doubleclick.net/pagead/ads?client=ca-games-pub-4405534753933673&slotname=2910065387&ad_type=video_image&description_url=http%3A%2F%2Ffreegamescasual.com%2FFree-Online-Games%2FPrincesses%2FPrincess-Anti-Fashion-Sporty--Classy.html&videoad_start_delay=15000';
            Config.BANNERS = false;
            Config.REVERS = false;
            Config.PROMO = [
                { url: 'http://freegamescasual.com/Free-Online-Games/Princesses/Fashion-Eve-with-Royal-Sisters.html?clear_cache=1', image: 'promo_0.png', x: 0, y: 0 },
                { url: 'http://freegamescasual.com/Free-Online-Games/Princesses/Princess-Punk-Street-Style-Contest.html?clear_cache=1', image: 'promo_1.png', x: 0, y: 0 }
            ];
            Config.CROSS = [
                'http://freegamescasual.com/Free-Online-Games/Princesses/Fashion-Eve-with-Royal-Sisters.html?clear_cache=1',
                'http://freegamescasual.com/Free-Online-Games/Princesses/Princess-Punk-Street-Style-Contest.html?clear_cache=1'
            ];
            Config.BACK = [
                { name: 'Back', image: 'Back', exp: 'jpg' },
                { name: 'BackStart', image: 'BackStart', exp: 'jpg' },
                { name: 'BackAnim_0', image: 'BackAnim_0', exp: 'jpg' },
                { name: 'BackAnim_1', image: 'BackAnim_1', exp: 'jpg' },
                { name: 'BackDress', image: 'BackDress', exp: 'jpg' },
                { name: 'BackEnd', image: 'BackEnd', exp: 'jpg' }
            ];
            Config.ATLAS = [
                'JAS', 'ANN', 'AUR',
                'WA_ALL',
                'WA_JAS', 'WA_ANN', 'WA_AUR',
                'GameObjects', 'Particles',
                'ExtraMore'
            ];
            return Config;
        }());
        Client.Config = Config;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var DressConfig = (function () {
            function DressConfig() {
            }
            DressConfig.DOLLS = [
                {
                    atlas: 'JAS',
                    images: [
                        'hb0', 'hb1', 'hb2', 'hb3', 'hb4', 'hb5', 'hb6',
                        'db1',
                        'cb4',
                        'jb1',
                        'cb2',
                        'ab1',
                        'pb3', 'pb4', 'pb1', 'pb2',
                        'body',
                        'under_b', 'under_t',
                        'sf1', 'sf2', 'sf3', 'sf5', 'sf6',
                        'bf3', 'bf1', 'bf4', 'bf2',
                        'sf4',
                        'tf1', 'tf2', 'tf3', 'tf4',
                        'df3', 'df5', 'df4', 'df1', 'df2',
                        'pf1', 'pf2', 'pf3',
                        'cf4',
                        'pf4',
                        'cf1',
                        'af1',
                        'cf2', 'cf3',
                        'head',
                        'of2', 'of1',
                        'hf0', 'hf1', 'hf2', 'hf3', 'hf4', 'hf5', 'hf6',
                        'jf1',
                        'hand'
                    ],
                    items: {
                        h0: ['hf0', 'hb0'], h1: ['hf1', 'hb1'], h2: ['hf2', 'hb2'], h3: ['hf3', 'hb3'], h4: ['hf4', 'hb4'], h5: ['hf5', 'hb5'], h6: ['hf6', 'hb6'],
                        d1: ['df1', 'db1'], d2: ['df2'], d3: ['df3'], d4: ['df4'], d5: ['df5'],
                        t1: ['tf1'], t2: ['tf2'], t3: ['tf3'], t4: ['tf4'],
                        b1: ['bf1'], b2: ['bf2'], b3: ['bf3'], b4: ['bf4'],
                        s1: ['sf1'], s2: ['sf2'], s3: ['sf3'], s4: ['sf4'], s5: ['sf5'], s6: ['sf6'],
                        p1: ['pf1', 'pb1'], p2: ['pf2', 'pb2'], p3: ['pf3', 'pb3'], p4: ['pf4', 'pb4'],
                        j1: ['jf1', 'jb1'],
                        a1: ['af1', 'ab1'],
                        c1: ['cf1'], c2: ['cf2', 'cb2'], c3: ['cf3'], c4: ['cf4', 'cb4'],
                        o1: ['of1'], o2: ['of2']
                    },
                    sets: [
                        ['h0', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
                        [null, 'd1', 'd2', 'd3', 'd4', 'd5'],
                        [null, 't1', 't2', 't3', 't4'],
                        [null, 'b1', 'b2', 'b3', 'b4'],
                        [null, 's1', 's2', 's3', 's4', 's5', 's6'],
                        [null, 'p1', 'p2', 'p3', 'p4'],
                        [null, 'j1'],
                        [null, 'a1'],
                        [null, 'c1', 'c2', 'c3', 'c4'],
                        [null, 'o1', 'o2']
                    ]
                },
                {
                    atlas: 'ANN',
                    images: [
                        'hb0', 'hb1', 'hb2', 'hb3', 'hb4', 'hb5', 'hb6',
                        'pb1', 'pb2', 'pb3', 'pb4',
                        'bb4',
                        'db4',
                        'cb3',
                        'ab2',
                        'body',
                        'under_b', 'under_t',
                        'head',
                        'af3',
                        'sf2', 'sf3', 'sf4', 'sf5', 'sf6',
                        'bf1', 'bf2',
                        'sf1',
                        'bf3', 'bf4',
                        'tf1', 'tf2', 'tf3', 'tf4',
                        'df1', 'df2', 'df3', 'df4',
                        'pf1', 'pf2', 'pf3', 'pf4',
                        'cf3',
                        'af2', 'af1',
                        'hf0', 'hf1', 'hf2', 'hf3', 'hf4', 'hf5', 'hf6',
                        'cf2', 'cf1',
                        'hand'
                    ],
                    items: {
                        h0: ['hf0', 'hb0'], h1: ['hf1', 'hb1'], h2: ['hf2', 'hb2'], h3: ['hf3', 'hb3'], h4: ['hf4', 'hb4'], h5: ['hf5', 'hb5'], h6: ['hf6', 'hb6'],
                        d1: ['df1'], d2: ['df2'], d3: ['df3'], d4: ['df4', 'db4'],
                        t1: ['tf1'], t2: ['tf2'], t3: ['tf3'], t4: ['tf4'],
                        b1: ['bf1'], b2: ['bf2'], b3: ['bf3'], b4: ['bf4', 'bb4'],
                        s1: ['sf1'], s2: ['sf2'], s3: ['sf3'], s4: ['sf4'], s5: ['sf5'], s6: ['sf6'],
                        p1: ['pf1', 'pb1'], p2: ['pf2', 'pb2'], p3: ['pf3', 'pb3'], p4: ['pf4', 'pb4'],
                        a1: ['af1'], a2: ['af2', 'ab2'], a3: ['af3'],
                        c1: ['cf1'], c2: ['cf2'], c3: ['cf3', 'cb3']
                    },
                    sets: [
                        ['h0', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
                        [null, 'd1', 'd2', 'd3', 'd4'],
                        [null, 't1', 't2', 't3', 't4'],
                        [null, 'b1', 'b2', 'b3', 'b4'],
                        [null, 's1', 's2', 's3', 's4', 's5', 's6'],
                        [null, 'p1', 'p2', 'p3', 'p4'],
                        [null, 'a1', 'a2', 'a3'],
                        [null, 'c1', 'c2', 'c3']
                    ]
                },
                {
                    atlas: 'AUR',
                    images: [
                        'hb0', 'hb2', 'hb3', 'hb4', 'hb6',
                        'pb1', 'pb2', 'pb3', 'pb4',
                        'bb4',
                        'db4',
                        'cb3',
                        'ab2',
                        'body',
                        'under_b', 'under_t',
                        'af3',
                        'sf2', 'sf3', 'sf4', 'sf5', 'sf6',
                        'bf1', 'bf2',
                        'sf1',
                        'bf3', 'bf4',
                        'tf1', 'tf2', 'tf3', 'tf4',
                        'df1', 'df2', 'df3', 'df4',
                        'pf1', 'pf2', 'pf3', 'pf4',
                        'cf3',
                        'af2', 'af1',
                        'head',
                        'hf0', 'hf1', 'hf2', 'hf3', 'hf4', 'hf5', 'hf6',
                        'cf2', 'cf1',
                        'hand'
                    ],
                    items: {
                        h0: ['hf0', 'hb0'], h1: ['hf1'], h2: ['hf2', 'hb2'], h3: ['hf3', 'hb3'], h4: ['hf4', 'hb4'], h5: ['hf5'], h6: ['hf6', 'hb6'],
                        d1: ['df1'], d2: ['df2'], d3: ['df3'], d4: ['df4', 'db4'],
                        t1: ['tf1'], t2: ['tf2'], t3: ['tf3'], t4: ['tf4'],
                        b1: ['bf1'], b2: ['bf2'], b3: ['bf3'], b4: ['bf4', 'bb4'],
                        s1: ['sf1'], s2: ['sf2'], s3: ['sf3'], s4: ['sf4'], s5: ['sf5'], s6: ['sf6'],
                        p1: ['pf1', 'pb1'], p2: ['pf2', 'pb2'], p3: ['pf3', 'pb3'], p4: ['pf4', 'pb4'],
                        a1: ['af1'], a2: ['af2', 'ab2'], a3: ['af3'],
                        c1: ['cf1'], c2: ['cf2'], c3: ['cf3', 'cb3']
                    },
                    sets: [
                        ['h0', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
                        [null, 'd1', 'd2', 'd3', 'd4'],
                        [null, 't1', 't2', 't3', 't4'],
                        [null, 'b1', 'b2', 'b3', 'b4'],
                        [null, 's1', 's2', 's3', 's4', 's5', 's6'],
                        [null, 'p1', 'p2', 'p3', 'p4'],
                        [null, 'a1', 'a2', 'a3'],
                        [null, 'c1', 'c2', 'c3']
                    ]
                }
            ];
            DressConfig.DRESSING_CONFIG = [
                {
                    atlas: 'WA_JAS',
                    doll: 0,
                    pages: [
                        ['s6', 's2', 's3', 's1', 's5', 's4', 'd1', 'd2', 'd3', 'd5', 'd4', 'a1', 'c2', 'o2', 'j1'],
                        ['s6', 's2', 's3', 's1', 's5', 's4', 'p1', 'p2', 'c3', 'o1', 'p3', 'p4', 'c4', 'c1'],
                        ['s6', 's2', 's3', 's1', 's5', 's4', 'a1', 'c2', 'o2', 'j1', 'b2', 'b4', 't3', 't4', 'b1', 't1', 't2', 'b3'],
                        ['s6', 's2', 's3', 's1', 's5', 's4'],
                        []
                    ],
                    inside: [
                        [{ image: 'back_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'back_1', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'shadow', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_1', top: false, type: 'i', atlas: 'WA_JAS' }],
                        [{ image: 'back_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'back_1', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'shadow', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_1', top: false, type: 'i', atlas: 'WA_JAS' }],
                        [{ image: 'back_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'back_1', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'shadow', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_1', top: false, type: 'i', atlas: 'WA_JAS' }],
                        [{ image: 'back_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'back_1', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'shadow', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'label_1', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'mirror_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'mirror_1', top: false, type: 'i', atlas: 'WA_JAS' }],
                        [{ image: 'back_0', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'back_1', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'shadow', top: false, type: 'i', atlas: 'WA_JAS' }, { image: 'more_0', top: false, type: 'm', atlas: 'WA_JAS' }, { image: 'more_1', top: false, type: 'm', atlas: 'WA_JAS' }, { image: 'promo', top: false, type: 'p', atlas: 'WA_JAS', ID: 0 }]
                    ],
                    carousels: [
                        { id: 0, view: 0, page: 3 },
                        { id: 1, view: 0, page: 3 },
                    ],
                    combined: [{ set1: 1, set2: [2, 3] }],
                    arrow: { view: 'two', atlas: 'WA_JAS' },
                    skiped: true,
                    hidden: false
                },
                {
                    atlas: 'WA_ALL',
                    doll: 1,
                    pages: [
                        ['s2', 's3', 's1', 's5', 's4', 's6', 'd2', 'd1', 'a3', 'd3', 'd4', 'c2'],
                        ['s2', 's3', 's1', 's5', 's4', 's6', 'p3', 'p4', 'c1', 'p2', 'p1', 'c3'],
                        ['s2', 's3', 's1', 's5', 's4', 's6', 't1', 'b1', 'b2', 't2', 'a1', 'b4', 'b3', 't3', 't4', 'a2'],
                        ['s2', 's3', 's1', 's5', 's4', 's6'],
                        []
                    ],
                    inside: [
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' }
                        ],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' }
                        ],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' }],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'mirror_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'mirror_1', top: false, type: 'i', atlas: 'WA_ALL' }],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'promo_0', top: false, type: 'p', atlas: 'WA_ALL', ID: 0 },
                            { image: 'promo_1', top: false, type: 'p', atlas: 'WA_ALL', ID: 1 }
                        ]
                    ],
                    carousels: [
                        { id: 2, view: 0, page: 3 },
                        { id: 3, view: 0, page: 3 },
                    ],
                    combined: [{ set1: 1, set2: [2, 3] }],
                    arrow: { view: 'two', atlas: 'WA_ALL' },
                    skiped: true,
                    hidden: false
                },
                {
                    atlas: 'WA_ALL',
                    doll: 2,
                    pages: [
                        ['s2', 's3', 's1', 's5', 's4', 's6', 'd2', 'd1', 'a3', 'd3', 'd4', 'c2'],
                        ['s2', 's3', 's1', 's5', 's4', 's6', 'p3', 'p4', 'c1', 'p2', 'p1', 'c3'],
                        ['s2', 's3', 's1', 's5', 's4', 's6', 't1', 'b1', 'b2', 't2', 'a1', 'b4', 'b3', 't3', 't4', 'a2'],
                        ['s2', 's3', 's1', 's5', 's4', 's6'],
                        []
                    ],
                    inside: [
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' }
                        ],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' }
                        ],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' }],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'label_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'mirror_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'mirror_1', top: false, type: 'i', atlas: 'WA_ALL' }],
                        [
                            { image: 'back_0', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'back_1', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'shadow', top: false, type: 'i', atlas: 'WA_ALL' },
                            { image: 'promo_0', top: false, type: 'p', atlas: 'WA_ALL', ID: 0 },
                            { image: 'promo_1', top: false, type: 'p', atlas: 'WA_ALL', ID: 1 }
                        ]
                    ],
                    carousels: [
                        { id: 4, view: 0, page: 3 },
                        { id: 5, view: 0, page: 3 },
                    ],
                    combined: [{ set1: 1, set2: [2, 3] }],
                    arrow: { view: 'two', atlas: 'WA_ALL' },
                    skiped: true,
                    hidden: false
                }
            ];
            DressConfig.CAROUSELS = [
                {
                    atlas: 'WA_JAS',
                    images: ['h4', 'h5', 'h6'],
                    begin: 4,
                    end: 6,
                    empty: false,
                    anim: null
                },
                {
                    atlas: 'WA_JAS',
                    images: ['h1', 'h2', 'h3'],
                    begin: 1,
                    end: 3,
                    empty: false,
                    anim: null
                },
                {
                    atlas: 'WA_ANN',
                    images: ['h4', 'h5', 'h6'],
                    begin: 4,
                    end: 6,
                    empty: false,
                    anim: null
                },
                {
                    atlas: 'WA_ANN',
                    images: ['h1', 'h2', 'h3'],
                    begin: 1,
                    end: 3,
                    empty: false,
                    anim: null
                }, {
                    atlas: 'WA_AUR',
                    images: ['h4', 'h5', 'h6'],
                    begin: 4,
                    end: 6,
                    empty: false,
                    anim: null
                },
                {
                    atlas: 'WA_AUR',
                    images: ['h1', 'h2', 'h3'],
                    begin: 1,
                    end: 3,
                    empty: false,
                    anim: null
                }
            ];
            return DressConfig;
        }());
        Client.DressConfig = DressConfig;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Event = (function () {
            function Event() {
            }
            return Event;
        }());
        Client.Event = Event;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GlowFilter = (function (_super) {
            __extends(GlowFilter, _super);
            function GlowFilter(game, size) {
                if (size === void 0) { size = 0.05; }
                var fragmentSrc = [
                    'precision lowp float;',
                    'varying vec2 vTextureCoord;',
                    'varying vec4 vColor;',
                    'uniform sampler2D uSampler;',
                    'void main() {',
                    'vec4 sum = vec4(0);',
                    'vec2 texcoord = vTextureCoord;',
                    'for(int xx = -4; xx <= 4; xx++) {',
                    'for(int yy = -3; yy <= 3; yy++) {',
                    'float dist = sqrt(float(xx*xx) + float(yy*yy));',
                    'float factor = 0.0;',
                    'if (dist == 0.0) {',
                    'factor = 2.0;',
                    '} else {',
                    'factor = 2.0/abs(float(dist));',
                    '}',
                    'sum += texture2D(uSampler, texcoord + vec2(xx, yy) * 0.002) * factor;',
                    '}',
                    '}',
                    'gl_FragColor = sum * ' + size + ' + texture2D(uSampler, texcoord);',
                    '}'
                ];
                _super.call(this, game, null, fragmentSrc);
            }
            return GlowFilter;
        }(Phaser.Filter));
        Client.GlowFilter = GlowFilter;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var GrayFilter = (function (_super) {
            __extends(GrayFilter, _super);
            function GrayFilter(game) {
                var fragmentSrc = [
                    'precision mediump float;',
                    'varying vec2       vTextureCoord;',
                    'varying vec4       vColor;',
                    'uniform sampler2D  uSampler;',
                    'uniform float      gray;',
                    'void main(void) {',
                    'gl_FragColor = texture2D(uSampler, vTextureCoord);',
                    'gl_FragColor.rgb = mix(gl_FragColor.rgb, vec3(0.2126 * gl_FragColor.r + 0.7152 * gl_FragColor.g + 0.0722 * gl_FragColor.b), gray);',
                    '}'
                ];
                _super.call(this, game, null, fragmentSrc);
                this.uniforms.gray = { type: '1f', value: 1.0 };
            }
            return GrayFilter;
        }(Phaser.Filter));
        Client.GrayFilter = GrayFilter;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var SaturationFilter = (function (_super) {
            __extends(SaturationFilter, _super);
            function SaturationFilter(game, saturation) {
                if (saturation === void 0) { saturation = 0.2; }
                var fragmentSrc = [
                    'precision mediump float;',
                    'varying vec2       vTextureCoord;',
                    'uniform sampler2D  uSampler;',
                    'void main(void) {',
                    'gl_FragColor = texture2D(uSampler, vTextureCoord);',
                    'float average = (gl_FragColor.r + gl_FragColor.g + gl_FragColor.b) / 3.0;',
                    'gl_FragColor.rgb += (average - gl_FragColor.rgb) * (1.0 - 1.0 / (1.001 - ' + saturation + '));',
                    '}'
                ];
                _super.call(this, game, null, fragmentSrc);
            }
            return SaturationFilter;
        }(Phaser.Filter));
        Client.SaturationFilter = SaturationFilter;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Globals = (function () {
            function Globals() {
            }
            Globals.AD_SCREENS = [];
            Globals.NextScreenID = -1;
            Globals.GIRL_ID = -1;
            Globals.ANIM_ID = -1;
            Globals.DRESS_ID = -1;
            Globals.BACK_ID = -1;
            Globals.DELAY = 0;
            Globals.LOCATION = '';
            Globals.REPLAY_URL = '';
            Globals.FILENAME = '';
            Globals.GIRL = [];
            Globals.DOLLS_VIEW = [];
            Globals.MAKET = [];
            Globals.SCORE = [];
            Globals.SFX = true;
            Globals.PATH = -1;
            Globals.WINNER = -1;
            Globals.DONE = [];
            Globals.SP = { R: { x: 960, y: 0 }, L: { x: -960, y: 0 }, U: { x: 0, y: -720 }, D: { x: 0, y: 720 }, UR: { x: 960, y: -720 }, UL: { x: -960, y: -720 }, DR: { x: 960, y: 720 }, DL: { x: -960, y: 720 }, Z: { x: 0, y: 0 }, ZG: { x: 480, y: 360 } };
            return Globals;
        }());
        Client.Globals = Globals;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var MusicManager = (function () {
            function MusicManager() {
                this.music = Client.Globals.GAME.add.audio('music', 1, true);
                this.music.play();
            }
            MusicManager.prototype.onMusic = function (flag) {
                Client.Globals.SFX = flag;
                flag ? this.music.resume() : this.music.pause();
            };
            return MusicManager;
        }());
        Client.MusicManager = MusicManager;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var ScreenManager = (function (_super) {
            __extends(ScreenManager, _super);
            function ScreenManager(game) {
                _super.call(this, game);
                this.game = game;
                this.container = new Phaser.Group(this.game);
                this.container.pendingDestroy = true;
            }
            ScreenManager.prototype.addScreen = function (screen) {
                this.container.destroy(true, false);
                this.container = new Phaser.Group(this.game);
                this._screen = screen;
                this.container.add(this._screen);
                this._screen.init();
            };
            Object.defineProperty(ScreenManager.prototype, "screenID", {
                get: function () {
                    return this._screen.screenID;
                },
                enumerable: true,
                configurable: true
            });
            return ScreenManager;
        }(Phaser.Group));
        Client.ScreenManager = ScreenManager;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
var DressGame;
(function (DressGame) {
    var Client;
    (function (Client) {
        var Utils = (function () {
            function Utils() {
            }
            Utils.getMaxOfArray = function (numArray) {
                return Math.max.apply(null, numArray);
            };
            Utils.checkArr = function (arr, param) {
                if (param === void 0) { param = 0; }
                if (param == 0) {
                    var cnt = 0;
                    for (var i = 0; i < arr.length; i++) {
                        if (arr[i]) {
                            cnt++;
                        }
                    }
                    return cnt == arr.length ? true : false;
                }
                if (param == 1) {
                    for (var i = 0; i < arr.length; i++) {
                        if (arr[i]) {
                            return true;
                        }
                    }
                    return false;
                }
                if (param == 2) {
                    var cnt = 0;
                    for (var i = 0; i < arr.length; i++) {
                        if (arr[i] != -1) {
                            cnt++;
                        }
                    }
                    return cnt == arr.length ? true : false;
                }
            };
            Utils.inArray = function (needle, haystack) {
                var length = haystack.length;
                for (var i = 0; i < length; i++) {
                    if (haystack[i] == needle)
                        return true;
                }
                return false;
            };
            Utils.saveCanvas = function (game, params) {
                if (params === void 0) { params = null; }
                Client.Event.onScreenEvent.dispatch({ type: 'GUI', view: 'photo', action: 'setView' });
                var A0 = game.add.tween(this).to({}, 100, Phaser.Easing.Linear.None, true, 500);
                A0.onComplete.add(function () {
                    var link = document.createElement('a');
                    link.href = game.canvas.toDataURL('image/png');
                    link.download = Client.Globals.FILENAME;
                    document.body.appendChild(link);
                    link.click();
                    document.body.removeChild(link);
                }, this);
                var A1 = game.add.tween(this).to({}, 100, Phaser.Easing.Linear.None, true, 500);
                A1.onComplete.add(function () {
                    if (!params) {
                        Client.Event.onScreenEvent.dispatch({ type: 'GUI', view: 'end', action: 'setView' });
                    }
                    else {
                        Client.Event.onScreenEvent.dispatch({ type: 'GUI', view: 'end', action: 'setView', xy: params });
                    }
                }, this);
            };
            Utils.hide = function (elements) {
                elements = elements.length ? elements : [elements];
                for (var index = 0; index < elements.length; index++) {
                    elements[index].style.display = 'none';
                }
            };
            Utils.paintWhite = function (pixel) {
                pixel.r = pixel.g = pixel.b = 255;
                return pixel;
            };
            Utils.musicOn = function () {
                Client.Event.onAdEvent.dispatch({ screen: 'gui', type: 'music', action: 'on' });
            };
            Utils.musicOff = function () {
                Client.Event.onAdEvent.dispatch({ screen: 'gui', type: 'music', action: 'off' });
            };
            Utils.makeShoot = function (game, w, h, object) {
                var bmd = game.add.bitmapData(w, h);
                var oldTrans = { x: object.x, y: object.y, scaleX: object.scale.x, scaleY: object.scale.y, angle: object.angle };
                object.x = object.y = 0;
                object.scale.x = object.scale.y = 1;
                object.angle = 0;
                object.updateTransform();
                bmd.drawGroup(object);
                object.x = oldTrans.x;
                object.y = oldTrans.y;
                object.scale.x = oldTrans.scaleX;
                object.scale.y = oldTrans.scaleY;
                object.angle = oldTrans.angle;
                object.updateTransform();
                return bmd;
            };
            Utils.getLocation = function (href) {
                var l = document.createElement('a');
                l.href = href;
                return l;
            };
            ;
            Utils.moreUrl = function (source) {
                if (source === void 0) { source = 'main_more_games'; }
                var url = (window.location != window.parent.location)
                    ? document.referrer
                    : document.location.href;
                var loc = this.getLocation(url);
                window.open(Client.Config.MORE_CONFIG['domain'] + "?utm_source=" + loc.hostname + "&utm_campaign=" + Client.Config.MORE_CONFIG['gameID'] + "&utm_medium=referral&utm_content=" + source);
            };
            Utils.onPromo = function (ID) {
                var url = document.referrer;
                var l = document.createElement('a');
                l.href = url;
                var loc = l;
                var promoURL = Client.Config.PROMO[ID]['url'] + "?utm_source=" + loc.hostname + "&utm_campaign=" + Client.Config.MORE_CONFIG.gameID + "&utm_medium=referral&utm_content=crosspromo";
                window.open(promoURL);
            };
            Utils.onCross = function (ID) {
                var url = document.referrer;
                var l = document.createElement('a');
                l.href = url;
                var loc = l;
                var promoURL = Client.Config.CROSS[ID] + "?utm_source=" + loc.hostname + "&utm_campaign=" + Client.Config.MORE_CONFIG.gameID + "&utm_medium=referral&utm_content=crosspromo";
                window.open(promoURL);
            };
            Utils.checkOverlap = function (spriteA, spriteB) {
                var boundsA = spriteA.getBounds();
                var boundsB = spriteB.getBounds();
                return Phaser.Rectangle.intersects(boundsA, boundsB);
            };
            Utils.getDomain = function () {
                if (Client.Config.PUBLISHER == 'F') {
                    return 'https://freegamescasual.com';
                }
                if (Client.Config.PUBLISHER == 'D') {
                    return 'https://dressupmix.com';
                }
                if (Client.Config.PUBLISHER == 'M') {
                    return 'https://mycutegames.com';
                }
                return 'NOT_SET_SITE';
            };
            Utils.showAD = function () {
                if (Client.Config.ADS_URL != '' && Client.Config.AD_PARAM.cnt < Client.Config.AD_PARAM.max) {
                    if (!Client.Config.AD_PARAM.lock) {
                        if (areAdsEnabled()) {
                            playAds();
                            Client.Config.AD_PARAM.cnt++;
                            console.log("start ad \u2116" + Client.Config.AD_PARAM.cnt);
                        }
                    }
                    else {
                        Client.Config.AD_PARAM.lock = false;
                    }
                }
            };
            Utils.getDollData = function () {
                var arr = [];
                for (var i = 0; i < Client.DressConfig.DOLLS.length; i++) {
                    arr.push([]);
                    for (var j = 0; j < Client.DressConfig.DOLLS[i].sets.length; j++) {
                        arr[i].push(0);
                    }
                }
                return arr;
            };
            Utils.Replay = function () {
                window.open(Client.Globals.REPLAY_URL + "?utm_source=" + Client.Globals.LOCATION + "&utm_campaign=" + Client.Config.MORE_CONFIG['gameID'] + "&utm_medium=referral&utm_content=replay");
            };
            return Utils;
        }());
        Client.Utils = Utils;
    })(Client = DressGame.Client || (DressGame.Client = {}));
})(DressGame || (DressGame = {}));
//# sourceMappingURL=game.js.map